// This file is licensed under the terms of the CC-LGPL.
//
// La version original fue hecha con el modelador Moray
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 16 agosto 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ADVERTENCIA: El objeto es incompatible con POVRay 3.1.
//
// La macro ADPC_AvionDouglas()
// crea un avion comercial estilo Douglas
// En su version sin llantas descansa sobre el plano XY
// la cabeza hacia x+.
// La parte delantera de las alas principales
// sobre el origen.
// LargoPrincipal       = 40750*L
// AnchoTotal           = 37170*L
// AltoTotal            = 12740*L (con llantas)
// AltoTotal            = 10970*L (sin llantas)
// AnchoTronco          = 4780*L
// AltoTronco           = 4200*L
// AnchoAlasTraseras    = 15530*L
// AltoLlantas          = 1770*L
// Frente               = sobresale 15930*L en x+
// 
// El objeto se genera via la siguiente macro
// #macro ADPC_AvionDouglas
//              ( AnguloI1, AnguloI2, AnguloI3, AnguloI4, 
//                AnguloD1, AnguloD2, AnguloD3, AnguloD4 )
//          Nota: Angulos positivos hacia arriba.  Izquierda y derecha
//              respecto del piloto del avion. Numerados
//              de dentro hacia el exterior.
//      AnguloI1                : Giro del aleron interior izquierdo
//      AnguloI2                : Giro del segundo aleron izquierdo
//      AnguloI3                : Giro del tercer aleron izquierdo
//      AnguloI4                : Giro del cuarto aleron izquierdo
//      AnguloD1                : Giro del aleron interior derecho  
//      AnguloD2                : Giro del segundo aleron derecho   
//      AnguloD3                : Giro del tercer aleron derecho   
//      AnguloD4                : Giro del cuarto aleron derecho  
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ADPC_BanderaRueda   = on;
//      Valor off no dibuja las llantas, ni las puertecillas.
// 
// Para colocarlo simplemente
// #include "ADPC.inc"
// object { ADPC_AvionDouglas( 0,0,0,0,0,0,0,0 ) }
//
// O si se utiliza el modificador
// #include "ADPC.inc"
// #declare ADPC_BanderaRueda   = off;
// object { ADPC_AvionDouglas( 0,0,0,0,0,0,0,0 ) }
//
// AvionDouglasPersonalComputer   

//
// ********  MATERIALS  *******
//

#include "ADPC_Mat.inc" 
#include "transforms.inc"

#ifndef ( ADPC_BanderaRueda )
  #declare ADPC_BanderaRueda    = on;
#end
//
// ********  REFERENCED OBJECTS  *******
//

#local Cube004 = object {
  box { // Cube004
    <-1, -1, -1>, <0.6, 1, 1>
    scale <1.4, 0.3, 0.03>
    translate  <1.391756, 0.124096, -2.456991>
  }
}
//
// Include file contains 'RotSweep003'
//
#include "ADPC_IN1"
#local RotSweep003 = object {
  ADPC_RotSweep003_Raw
  scale <0.27, 0.26, 1.04>
  rotate -90.0*y
  translate  <6.426127, 2.3795, 0.0>
}
#local RotSweep004 = lathe {
  linear_spline
  4  // control points
  <0.347689, -0.883516>,
  <1.347689, -0.383516>,
  <1.347689, 0.616484>,
  <1.652311, 0.976703>
  rotate <90,0,90>
  material {
    ADPC_Material2
  }
  scale <0.3, 0.3, 1.2>
  rotate -90.0*y
  translate  <6.578016, 2.3795, -0.03464>
}
#local Rotor = union {
  object { // Cube020 -> Cube004
    Cube004
    rotate 40.0*x
    translate  <0.0, -1.550291, -0.654594> 
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube021 -> Cube004
    Cube004
    rotate 20.0*x
    translate  <0.0, -0.832857, -0.190618>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube019 -> Cube004
    Cube004
    rotate 60.0*x
    translate  <0.0, -2.065769, -1.335966>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube018 -> Cube004
    Cube004
    rotate 80.0*x
    translate  <0.0, -2.317117, -2.15255>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube017 -> Cube004
    Cube004
    rotate 100.0*x
    translate  <0.0, -2.274019, -3.005854>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube015 -> Cube004
    Cube004
    rotate 140.0*x
    translate  <0.0, -1.360164, -4.418924>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube014 -> Cube004
    Cube004
    rotate 160.0*x
    translate  <0.0, -0.599632, -4.808252>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube016 -> Cube004
    Cube004
    rotate 120.0*x
    translate  <0.0, -1.941673, -3.792958>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube013 -> Cube004
    Cube004
    rotate 180.0*x
    translate  <0.0, 0.248192, -4.913983>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube011 -> Cube004
    Cube004
    rotate -140.0*x
    translate  <0.0, 1.798483, -4.259389>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube012 -> Cube004
    Cube004
    rotate -160.0*x
    translate  <0.0, 1.081049, -4.723365>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube010 -> Cube004
    Cube004
    rotate -120.0*x
    translate  <0.0, 2.313961, -3.578017>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube009 -> Cube004
    Cube004
    rotate -100.0*x
    translate  <0.0, 2.565309, -2.761433>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube008 -> Cube004
    Cube004
    rotate -80.0*x
    translate  <0.0, 2.522211, -1.908128>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube007 -> Cube004
    Cube004
    rotate -60.0*x
    translate  <0.0, 2.189865, -1.121025>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube006 -> Cube004
    Cube004
    rotate -40.0*x
    translate  <0.0, 1.608357, -0.495059>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { // Cube005 -> Cube004
    Cube004
    rotate -20.0*x
    translate  <0.0, 0.847824, -0.105731>
    texture     {
      ADPC_MetalMotor
    }
  }
  object { Cube004 
    texture     {
      ADPC_MetalMotor
    }
  }
  cylinder { // Cylndr001
    <0,0,1>, <0,0,0>, 1 
    material {
      ADPC_Material2
    }
    scale <0.35, 0.4, 0.4>
    rotate -90.0*y
    translate  <1.53217, 0.116877, -2.448855>
  }
  scale <0.833333, 1.25, 1.25>
  rotate <0.0, -0.0, -0.0>
  translate  <5.37008, 2.234979, 3.078468>
}
#local CorrienteMotor1 = union {
  object { RotSweep003 }
  object { RotSweep004 }
  object { Rotor }
  scale <1.2, 0.8, 0.8>
  translate  <-7.304096, -2.024319, -3.581453>  
  translate     1.0*x
}
#local TaperSweep001 = prism {
  conic_sweep
  cubic_spline
  0.0,1.0
  10  // control points
  <-0.599549, 0.844588>,
  <-0.799774, -0.797889>,
  <-1.800903, -0.945251>,
  <1.0, -1.0>,
  <1.0, 0.023349>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-0.599549, 0.844588>,
  <-0.799774, -0.797889>,
  <-1.800903, -0.945251>
  rotate <90,0,90>
  translate  <0.103374, 0.0, -1.009355>
  scale <1.28, 0.1, 15.6>
  rotate <2.151767, -35.005157, 0.335252>
  translate  <0.727681, 0.42, 0.145942>
}
#local CSG001 = difference {
  object { TaperSweep001 }
  box { // Cube001
    <-1, -1, -1>, <1, 1, 1>
    scale 5.0
    translate  <5.86, 0.42, -12.85>
  }
  box { // Cube023
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.4, 0.920928>
    rotate -26.745226*y
    translate  <3.353418, 0.464955, -2.322843>
  }
  box { // Cube025
    <-1, -1, -1>, <1, 1, 1>
    rotate <-0.0, 5.883584, -0.0>
    translate  <0.469418, 0.0, -3.107986>
    scale <2.613628, 0.4, 0.493315>
    rotate <-0.0, 60.423519, -0.0>
    translate  <6.212961, 0.507955, -3.037729>
  }
  texture       {  
  ADPC_TexturaAla
  }
  translate  <-0.86, -0.42, 0.0>
}
#declare ADPC_BaseAla = union {
  object { CorrienteMotor1 }
  object { CSG001 }
  translate  <0.86, 0.42, 0.0>
}
#local TaperSweep002 = prism {
  conic_sweep
  cubic_spline
  0.0,1.0
  10  // control points
  <-0.513457, 0.701035>,
  <-0.815085, -0.710135>,
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <0.964835, -0.018824>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-0.513457, 0.701035>,
  <-0.815085, -0.710135>,
  <-1.0, -1.0>
  rotate <90,0,90>
  translate  -1.034414*z
  scale <1.0, 0.1, 6.14>
  rotate <2.473421, -36.062588, 0.758343>
  translate  0.211304*z
}
#declare ADPC_AlaTrasera = difference {
  object { TaperSweep002 }
  box { // Cube002
    <-1, -1, -1>, <1, 1, 1>
    scale 3.0
    translate  <3.0, 0.0, -6.45>
  }
  texture       {  
    ADPC_TexturaAla  
    translate +5*x-10*z
  }
  translate  <7.7, 1.2, 0.0>
}




//
// ********  OBJECTS  *******
//

#local TransSweep001 = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  11  // control points
  <-0.75, 0.75>,
  <-1.0, 0.0>,
  <-0.75, -0.9>,
  <0.0, -1.0>,
  <0.75, -0.9>,
  <1.0, 0.0>,
  <0.75, 0.75>,
  <0.0, 1.0>,
  <-0.75, 0.75>,
  <-1.0, 0.0>,
  <-0.75, -0.9>
  rotate -x*90
  scale <0.95, 0.95, 10.68>
  rotate -90.0*y
  translate  <5.98, 0.95, 0.0>
}
#local TMesh001 = mesh2 {
  vertex_vectors {
    64,
    <-0.7500000, -0.9000000, 0.0000000>,
    <-0.5915805, -0.6867800, 1.1484405>,
    <-0.5976563, -0.9859375, 0.0000000>,
    <-0.4768979, -0.7514728, 1.1484405>,
    <-0.4062500, -1.0125000, 0.0000000>,
    <-0.3328095, -0.7714687, 1.1484405>,
    <-0.1992188, -1.0078125, 0.0000000>,
    <-0.1769588, -0.7679400, 1.1484405>,
    <0.0000000, -1.0000000, 0.0000000>,
    <-0.0269892, -0.7620589, 1.1484405>,
    <0.1992188, -1.0078125, 0.0000000>,
    <0.1229804, -0.7679400, 1.1484405>,
    <0.4062500, -1.0125000, 0.0000000>,
    <0.2788311, -0.7714687, 1.1484405>,
    <0.5976563, -0.9859375, 0.0000000>,
    <0.4229195, -0.7514728, 1.1484405>,
    <0.7500000, -0.9000000, 0.0000000>,
    <0.5376021, -0.6867800, 1.1484405>,
    <0.8593750, -0.7277344, 0.0000000>,
    <0.6199384, -0.5571004, 1.1484405>,
    <0.9375000, -0.4906250, 0.0000000>,
    <0.6787500, -0.3786073, 1.1484405>,
    <0.9843750, -0.2332031, 0.0000000>,
    <0.7140369, -0.1848230, 1.1484405>,
    <1.0000000, 0.0000000, 0.0000000>,
    <0.7257992, -0.0092704, 1.1484405>,
    <0.9843750, 0.2097656, 0.0000000>,
    <0.7140369, 0.1486387, 1.1484405>,
    <0.9375000, 0.4156250, 0.0000000>,
    <0.6787500, 0.3036073, 1.1484405>,
    <0.8593750, 0.6011719, 0.0000000>,
    <0.6199384, 0.4432848, 1.1484405>,
    <0.7500000, 0.7500000, 0.0000000>,
    <0.5376021, 0.5553209, 1.1484405>,
    <0.5976563, 0.8593750, 0.0000000>,
    <0.4229195, 0.6376571, 1.1484405>,
    <0.4062500, 0.9375000, 0.0000000>,
    <0.2788311, 0.6964687, 1.1484405>,
    <0.1992188, 0.9843750, 0.0000000>,
    <0.1229804, 0.7317557, 1.1484405>,
    <0.0000000, 1.0000000, 0.0000000>,
    <-0.0269892, 0.7435180, 1.1484405>,
    <-0.1992188, 0.9843750, 0.0000000>,
    <-0.1769588, 0.7317557, 1.1484405>,
    <-0.4062500, 0.9375000, 0.0000000>,
    <-0.3328095, 0.6964687, 1.1484405>,
    <-0.5976563, 0.8593750, 0.0000000>,
    <-0.4768979, 0.6376571, 1.1484405>,
    <-0.7500000, 0.7500000, 0.0000000>,
    <-0.5915805, 0.5553209, 1.1484405>,
    <-0.8593750, 0.6011719, 0.0000000>,
    <-0.6739167, 0.4432848, 1.1484405>,
    <-0.9375000, 0.4156250, 0.0000000>,
    <-0.7327283, 0.3036073, 1.1484405>,
    <-0.9843750, 0.2097656, 0.0000000>,
    <-0.7680153, 0.1486387, 1.1484405>,
    <-1.0000000, 0.0000000, 0.0000000>,
    <-0.7797776, -0.0092704, 1.1484405>,
    <-0.9843750, -0.2332031, 0.0000000>,
    <-0.7680153, -0.1848230, 1.1484405>,
    <-0.9375000, -0.4906250, 0.0000000>,
    <-0.7327283, -0.3786073, 1.1484405>,
    <-0.8593750, -0.7277344, 0.0000000>,
    <-0.6739167, -0.5571004, 1.1484405>
  }
  normal_vectors {
    92,
    <-0.4788739, -0.8489128, 0.2236669>,
    <-0.1343408, -0.9680443, 0.2117611>,
    <0.0221597, -0.9787213, 0.2039940>,
    <0.0383649, -0.9783037, 0.2035927>,
    <-0.0383789, -0.9786615, 0.2018633>,
    <-0.0221644, -0.9789288, 0.2029955>,
    <0.1341589, -0.9667333, 0.2177800>,
    <0.4763617, -0.8444594, 0.2448832>,
    <0.8179082, -0.5193068, 0.2476824>,
    <0.9225939, -0.3039848, 0.2375159>,
    <0.9568437, -0.1742356, 0.2325770>,
    <0.9707195, -0.0650398, 0.2312432>,
    <0.9699864, 0.0722522, 0.2321764>,
    <0.9478298, 0.2158246, 0.2346026>,
    <0.8950573, 0.3768662, 0.2384205>,
    <0.7818480, 0.5745865, 0.2420002>,
    <0.5663801, 0.7888865, 0.2384779>,
    <0.3677736, 0.9010453, 0.2299130>,
    <0.2152445, 0.9506632, 0.2234036>,
    <0.0762926, 0.9727301, 0.2190334>,
    <-0.0763521, 0.9734887, 0.2156156>,
    <-0.2157216, 0.9527702, 0.2137596>,
    <-0.3691884, 0.9045115, 0.2134451>,
    <-0.5698058, 0.7936581, 0.2131386>,
    <-0.7883534, 0.5793673, 0.2069600>,
    <-0.9033568, 0.3803607, 0.1981722>,
    <-0.9569246, 0.2178956, 0.1918769>,
    <-0.9793805, 0.0729520, 0.1883927>,
    <-0.9800846, -0.0656673, 0.1874087>,
    <-0.9660146, -0.1759055, 0.1894020>,
    <-0.9313518, -0.3068705, 0.1959957>,
    <-0.8251877, -0.5239287, 0.2111018>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>
  }
  face_indices {
    124,   // 60 triangles and 32 quads
    <0, 2, 3>,
    <0, 3, 1>,
    <2, 4, 5>,
    <2, 5, 3>,
    <4, 6, 7>,
    <4, 7, 5>,
    <6, 8, 9>,
    <6, 9, 7>,
    <8, 10, 11>,
    <8, 11, 9>,
    <10, 12, 13>,
    <10, 13, 11>,
    <12, 14, 15>,
    <12, 15, 13>,
    <14, 16, 17>,
    <14, 17, 15>,
    <16, 18, 19>,
    <16, 19, 17>,
    <18, 20, 21>,
    <18, 21, 19>,
    <20, 22, 23>,
    <20, 23, 21>,
    <22, 24, 25>,
    <22, 25, 23>,
    <24, 26, 27>,
    <24, 27, 25>,
    <26, 28, 29>,
    <26, 29, 27>,
    <28, 30, 31>,
    <28, 31, 29>,
    <30, 32, 33>,
    <30, 33, 31>,
    <32, 34, 35>,
    <32, 35, 33>,
    <34, 36, 37>,
    <34, 37, 35>,
    <36, 38, 39>,
    <36, 39, 37>,
    <38, 40, 41>,
    <38, 41, 39>,
    <40, 42, 43>,
    <40, 43, 41>,
    <42, 44, 45>,
    <42, 45, 43>,
    <44, 46, 47>,
    <44, 47, 45>,
    <46, 48, 49>,
    <46, 49, 47>,
    <48, 50, 51>,
    <48, 51, 49>,
    <50, 52, 53>,
    <50, 53, 51>,
    <52, 54, 55>,
    <52, 55, 53>,
    <54, 56, 57>,
    <54, 57, 55>,
    <56, 58, 59>,
    <56, 59, 57>,
    <58, 60, 61>,
    <58, 61, 59>,
    <60, 62, 63>,
    <60, 63, 61>,
    <62, 0, 1>,
    <62, 1, 63>,
    <0, 4, 2>,
    <1, 3, 5>,
    <0, 6, 4>,
    <1, 5, 7>,
    <0, 8, 6>,
    <1, 7, 9>,
    <0, 10, 8>,
    <1, 9, 11>,
    <0, 12, 10>,
    <1, 11, 13>,
    <0, 14, 12>,
    <1, 13, 15>,
    <0, 16, 14>,
    <1, 15, 17>,
    <0, 18, 16>,
    <1, 17, 19>,
    <0, 20, 18>,
    <1, 19, 21>,
    <0, 22, 20>,
    <1, 21, 23>,
    <0, 24, 22>,
    <1, 23, 25>,
    <0, 26, 24>,
    <1, 25, 27>,
    <0, 28, 26>,
    <1, 27, 29>,
    <0, 30, 28>,
    <1, 29, 31>,
    <0, 32, 30>,
    <1, 31, 33>,
    <0, 34, 32>,
    <1, 33, 35>,
    <0, 36, 34>,
    <1, 35, 37>,
    <0, 38, 36>,
    <1, 37, 39>,
    <0, 40, 38>,
    <1, 39, 41>,
    <0, 42, 40>,
    <1, 41, 43>,
    <0, 44, 42>,
    <1, 43, 45>,
    <0, 46, 44>,
    <1, 45, 47>,
    <0, 48, 46>,
    <1, 47, 49>,
    <0, 50, 48>,
    <1, 49, 51>,
    <0, 52, 50>,
    <1, 51, 53>,
    <0, 54, 52>,
    <1, 53, 55>,
    <0, 56, 54>,
    <1, 55, 57>,
    <0, 58, 56>,
    <1, 57, 59>,
    <0, 60, 58>,
    <1, 59, 61>,
    <0, 62, 60>,
    <1, 61, 63>
  }
  normal_indices {
    124,   // from 60 triangles and 32 quads
    <0, 0, 0>,
    <0, 0, 0>,
    <1, 1, 1>,
    <1, 1, 1>,
    <2, 2, 2>,
    <2, 2, 2>,
    <3, 3, 3>,
    <3, 3, 3>,
    <4, 4, 4>,
    <4, 4, 4>,
    <5, 5, 5>,
    <5, 5, 5>,
    <6, 6, 6>,
    <6, 6, 6>,
    <7, 7, 7>,
    <7, 7, 7>,
    <8, 8, 8>,
    <8, 8, 8>,
    <9, 9, 9>,
    <9, 9, 9>,
    <10, 10, 10>,
    <10, 10, 10>,
    <11, 11, 11>,
    <11, 11, 11>,
    <12, 12, 12>,
    <12, 12, 12>,
    <13, 13, 13>,
    <13, 13, 13>,
    <14, 14, 14>,
    <14, 14, 14>,
    <15, 15, 15>,
    <15, 15, 15>,
    <16, 16, 16>,
    <16, 16, 16>,
    <17, 17, 17>,
    <17, 17, 17>,
    <18, 18, 18>,
    <18, 18, 18>,
    <19, 19, 19>,
    <19, 19, 19>,
    <20, 20, 20>,
    <20, 20, 20>,
    <21, 21, 21>,
    <21, 21, 21>,
    <22, 22, 22>,
    <22, 22, 22>,
    <23, 23, 23>,
    <23, 23, 23>,
    <24, 24, 24>,
    <24, 24, 24>,
    <25, 25, 25>,
    <25, 25, 25>,
    <26, 26, 26>,
    <26, 26, 26>,
    <27, 27, 27>,
    <27, 27, 27>,
    <28, 28, 28>,
    <28, 28, 28>,
    <29, 29, 29>,
    <29, 29, 29>,
    <30, 30, 30>,
    <30, 30, 30>,
    <31, 31, 31>,
    <31, 31, 31>,
    <32, 32, 32>,
    <33, 33, 33>,
    <34, 34, 34>,
    <35, 35, 35>,
    <36, 36, 36>,
    <37, 37, 37>,
    <38, 38, 38>,
    <39, 39, 39>,
    <40, 40, 40>,
    <41, 41, 41>,
    <42, 42, 42>,
    <43, 43, 43>,
    <44, 44, 44>,
    <45, 45, 45>,
    <46, 46, 46>,
    <47, 47, 47>,
    <48, 48, 48>,
    <49, 49, 49>,
    <50, 50, 50>,
    <51, 51, 51>,
    <52, 52, 52>,
    <53, 53, 53>,
    <54, 54, 54>,
    <55, 55, 55>,
    <56, 56, 56>,
    <57, 57, 57>,
    <58, 58, 58>,
    <59, 59, 59>,
    <60, 60, 60>,
    <61, 61, 61>,
    <62, 62, 62>,
    <63, 63, 63>,
    <64, 64, 64>,
    <65, 65, 65>,
    <66, 66, 66>,
    <67, 67, 67>,
    <68, 68, 68>,
    <69, 69, 69>,
    <70, 70, 70>,
    <71, 71, 71>,
    <72, 72, 72>,
    <73, 73, 73>,
    <74, 74, 74>,
    <75, 75, 75>,
    <76, 76, 76>,
    <77, 77, 77>,
    <78, 78, 78>,
    <79, 79, 79>,
    <80, 80, 80>,
    <81, 81, 81>,
    <82, 82, 82>,
    <83, 83, 83>,
    <84, 84, 84>,
    <85, 85, 85>,
    <86, 86, 86>,
    <87, 87, 87>,
    <88, 88, 88>,
    <89, 89, 89>,
    <90, 90, 90>,
    <91, 91, 91>
  }
  scale <0.95, 0.95, 1.0>
  rotate -90.0*y
  translate  <-4.7, 0.95, 0.0>
}

#local TMesh002 = mesh2 {
  vertex_vectors {
    64,
    <-0.5333105, -0.2631262, -0.2248892>,
    <-0.7500000, -0.9000000, 1.0000000>,
    <-0.4266760, -0.3232789, -0.2248892>,
    <-0.5976563, -0.9859375, 1.0000000>,
    <-0.2926993, -0.3418716, -0.2248892>,
    <-0.4062500, -1.0125000, 1.0000000>,
    <-0.1477858, -0.3385906, -0.2248892>,
    <-0.1992188, -1.0078125, 1.0000000>,
    <-0.0083407, -0.3331221, -0.2248892>,
    <0.0000000, -1.0000000, 1.0000000>,
    <0.1311044, -0.3385906, -0.2248892>,
    <0.1992188, -1.0078125, 1.0000000>,
    <0.2760180, -0.3418716, -0.2248892>,
    <0.4062500, -1.0125000, 1.0000000>,
    <0.4099946, -0.3232789, -0.2248892>,
    <0.5976563, -0.9859375, 1.0000000>,
    <0.5166291, -0.2631262, -0.2248892>,
    <0.7500000, -0.9000000, 1.0000000>,
    <0.5931872, -0.1425472, -0.2248892>,
    <0.8593750, -0.7277344, 1.0000000>,
    <0.6478716, 0.0234199, -0.2248892>,
    <0.9375000, -0.4906250, 1.0000000>,
    <0.6806822, 0.2036048, -0.2248892>,
    <0.9843750, -0.2332031, 1.0000000>,
    <0.6916191, 0.3668376, -0.2248892>,
    <1.0000000, 0.0000000, 1.0000000>,
    <0.6806822, 0.5136651, -0.2248892>,
    <0.9843750, 0.2097656, 1.0000000>,
    <0.6478716, 0.6577584, -0.2248892>,
    <0.9375000, 0.4156250, 1.0000000>,
    <0.5931872, 0.7876337, -0.2248892>,
    <0.8593750, 0.6011719, 1.0000000>,
    <0.5166291, 0.8918074, -0.2248892>,
    <0.7500000, 0.7500000, 1.0000000>,
    <0.4099946, 0.9683655, -0.2248892>,
    <0.5976563, 0.8593750, 1.0000000>,
    <0.2760180, 1.0230498, -0.2248892>,
    <0.4062500, 0.9375000, 1.0000000>,
    <0.1311044, 1.0558605, -0.2248892>,
    <0.1992188, 0.9843750, 1.0000000>,
    <-0.0083407, 1.0667973, -0.2248892>,
    <0.0000000, 1.0000000, 1.0000000>,
    <-0.1477858, 1.0558605, -0.2248892>,
    <-0.1992188, 0.9843750, 1.0000000>,
    <-0.2926993, 1.0230498, -0.2248892>,
    <-0.4062500, 0.9375000, 1.0000000>,
    <-0.4266760, 0.9683655, -0.2248892>,
    <-0.5976563, 0.8593750, 1.0000000>,
    <-0.5333105, 0.8918074, -0.2248892>,
    <-0.7500000, 0.7500000, 1.0000000>,
    <-0.6098686, 0.7876337, -0.2248892>,
    <-0.8593750, 0.6011719, 1.0000000>,
    <-0.6645529, 0.6577584, -0.2248892>,
    <-0.9375000, 0.4156250, 1.0000000>,
    <-0.6973635, 0.5136651, -0.2248892>,
    <-0.9843750, 0.2097656, 1.0000000>,
    <-0.7083004, 0.3668376, -0.2248892>,
    <-1.0000000, 0.0000000, 1.0000000>,
    <-0.6973635, 0.2036048, -0.2248892>,
    <-0.9843750, -0.2332031, 1.0000000>,
    <-0.6645529, 0.0234199, -0.2248892>,
    <-0.9375000, -0.4906250, 1.0000000>,
    <-0.6098686, -0.1425472, -0.2248892>,
    <-0.8593750, -0.7277344, 1.0000000>
  }
  normal_vectors {
    92,
    <-0.4323564, -0.7664500, -0.4749973>,
    <-0.1201860, -0.8660463, -0.4853031>,
    <0.0198734, -0.8777415, -0.4787222>,
    <0.0344177, -0.8776513, -0.4780623>,
    <-0.0344254, -0.8778480, -0.4777006>,
    <-0.0198760, -0.8778552, -0.4785136>,
    <0.1200905, -0.8653581, -0.4865528>,
    <0.4311448, -0.7643021, -0.4795378>,
    <0.7728525, -0.4907000, -0.4023836>,
    <0.8947907, -0.2948240, -0.3353034>,
    <0.9402854, -0.1712204, -0.2941885>,
    <0.9629730, -0.0645208, -0.2617634>,
    <0.9721127, 0.0724106, -0.2230553>,
    <0.9584866, 0.2182512, -0.1834934>,
    <0.9125813, 0.3842448, -0.1398257>,
    <0.8029065, 0.5900625, -0.0846605>,
    <0.5831218, 0.8122054, -0.0170684>,
    <0.3777838, 0.9255702, 0.0244780>,
    <0.2206060, 0.9743430, 0.0445958>,
    <0.0780782, 0.9954969, 0.0537561>,
    <-0.0780737, 0.9954394, 0.0548163>,
    <-0.2205754, 0.9742081, 0.0475936>,
    <-0.3777312, 0.9254414, 0.0296188>,
    <-0.5831825, 0.8122899, -0.0091280>,
    <-0.8036027, 0.5905741, -0.0737900>,
    <-0.9141005, 0.3848844, -0.1276097>,
    <-0.9607084, 0.2187571, -0.1708352>,
    <-0.9749101, 0.0726190, -0.2104203>,
    <-0.9662122, -0.0647378, -0.2494854>,
    <-0.9437698, -0.1718549, -0.2824259>,
    <-0.8984021, -0.2960139, -0.3244217>,
    <-0.7761032, -0.4927640, -0.3935066>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>,
    <0.0000000, 0.0000000, -1.0000000>,
    <0.0000000, 0.0000000, 1.0000000>
  }
  face_indices {
    124,   // 60 triangles and 32 quads
    <0, 2, 3>,
    <0, 3, 1>,
    <2, 4, 5>,
    <2, 5, 3>,
    <4, 6, 7>,
    <4, 7, 5>,
    <6, 8, 9>,
    <6, 9, 7>,
    <8, 10, 11>,
    <8, 11, 9>,
    <10, 12, 13>,
    <10, 13, 11>,
    <12, 14, 15>,
    <12, 15, 13>,
    <14, 16, 17>,
    <14, 17, 15>,
    <16, 18, 19>,
    <16, 19, 17>,
    <18, 20, 21>,
    <18, 21, 19>,
    <20, 22, 23>,
    <20, 23, 21>,
    <22, 24, 25>,
    <22, 25, 23>,
    <24, 26, 27>,
    <24, 27, 25>,
    <26, 28, 29>,
    <26, 29, 27>,
    <28, 30, 31>,
    <28, 31, 29>,
    <30, 32, 33>,
    <30, 33, 31>,
    <32, 34, 35>,
    <32, 35, 33>,
    <34, 36, 37>,
    <34, 37, 35>,
    <36, 38, 39>,
    <36, 39, 37>,
    <38, 40, 41>,
    <38, 41, 39>,
    <40, 42, 43>,
    <40, 43, 41>,
    <42, 44, 45>,
    <42, 45, 43>,
    <44, 46, 47>,
    <44, 47, 45>,
    <46, 48, 49>,
    <46, 49, 47>,
    <48, 50, 51>,
    <48, 51, 49>,
    <50, 52, 53>,
    <50, 53, 51>,
    <52, 54, 55>,
    <52, 55, 53>,
    <54, 56, 57>,
    <54, 57, 55>,
    <56, 58, 59>,
    <56, 59, 57>,
    <58, 60, 61>,
    <58, 61, 59>,
    <60, 62, 63>,
    <60, 63, 61>,
    <62, 0, 1>,
    <62, 1, 63>,
    <0, 4, 2>,
    <1, 3, 5>,
    <0, 6, 4>,
    <1, 5, 7>,
    <0, 8, 6>,
    <1, 7, 9>,
    <0, 10, 8>,
    <1, 9, 11>,
    <0, 12, 10>,
    <1, 11, 13>,
    <0, 14, 12>,
    <1, 13, 15>,
    <0, 16, 14>,
    <1, 15, 17>,
    <0, 18, 16>,
    <1, 17, 19>,
    <0, 20, 18>,
    <1, 19, 21>,
    <0, 22, 20>,
    <1, 21, 23>,
    <0, 24, 22>,
    <1, 23, 25>,
    <0, 26, 24>,
    <1, 25, 27>,
    <0, 28, 26>,
    <1, 27, 29>,
    <0, 30, 28>,
    <1, 29, 31>,
    <0, 32, 30>,
    <1, 31, 33>,
    <0, 34, 32>,
    <1, 33, 35>,
    <0, 36, 34>,
    <1, 35, 37>,
    <0, 38, 36>,
    <1, 37, 39>,
    <0, 40, 38>,
    <1, 39, 41>,
    <0, 42, 40>,
    <1, 41, 43>,
    <0, 44, 42>,
    <1, 43, 45>,
    <0, 46, 44>,
    <1, 45, 47>,
    <0, 48, 46>,
    <1, 47, 49>,
    <0, 50, 48>,
    <1, 49, 51>,
    <0, 52, 50>,
    <1, 51, 53>,
    <0, 54, 52>,
    <1, 53, 55>,
    <0, 56, 54>,
    <1, 55, 57>,
    <0, 58, 56>,
    <1, 57, 59>,
    <0, 60, 58>,
    <1, 59, 61>,
    <0, 62, 60>,
    <1, 61, 63>
  }
  normal_indices {
    124,   // from 60 triangles and 32 quads
    <0, 0, 0>,
    <0, 0, 0>,
    <1, 1, 1>,
    <1, 1, 1>,
    <2, 2, 2>,
    <2, 2, 2>,
    <3, 3, 3>,
    <3, 3, 3>,
    <4, 4, 4>,
    <4, 4, 4>,
    <5, 5, 5>,
    <5, 5, 5>,
    <6, 6, 6>,
    <6, 6, 6>,
    <7, 7, 7>,
    <7, 7, 7>,
    <8, 8, 8>,
    <8, 8, 8>,
    <9, 9, 9>,
    <9, 9, 9>,
    <10, 10, 10>,
    <10, 10, 10>,
    <11, 11, 11>,
    <11, 11, 11>,
    <12, 12, 12>,
    <12, 12, 12>,
    <13, 13, 13>,
    <13, 13, 13>,
    <14, 14, 14>,
    <14, 14, 14>,
    <15, 15, 15>,
    <15, 15, 15>,
    <16, 16, 16>,
    <16, 16, 16>,
    <17, 17, 17>,
    <17, 17, 17>,
    <18, 18, 18>,
    <18, 18, 18>,
    <19, 19, 19>,
    <19, 19, 19>,
    <20, 20, 20>,
    <20, 20, 20>,
    <21, 21, 21>,
    <21, 21, 21>,
    <22, 22, 22>,
    <22, 22, 22>,
    <23, 23, 23>,
    <23, 23, 23>,
    <24, 24, 24>,
    <24, 24, 24>,
    <25, 25, 25>,
    <25, 25, 25>,
    <26, 26, 26>,
    <26, 26, 26>,
    <27, 27, 27>,
    <27, 27, 27>,
    <28, 28, 28>,
    <28, 28, 28>,
    <29, 29, 29>,
    <29, 29, 29>,
    <30, 30, 30>,
    <30, 30, 30>,
    <31, 31, 31>,
    <31, 31, 31>,
    <32, 32, 32>,
    <33, 33, 33>,
    <34, 34, 34>,
    <35, 35, 35>,
    <36, 36, 36>,
    <37, 37, 37>,
    <38, 38, 38>,
    <39, 39, 39>,
    <40, 40, 40>,
    <41, 41, 41>,
    <42, 42, 42>,
    <43, 43, 43>,
    <44, 44, 44>,
    <45, 45, 45>,
    <46, 46, 46>,
    <47, 47, 47>,
    <48, 48, 48>,
    <49, 49, 49>,
    <50, 50, 50>,
    <51, 51, 51>,
    <52, 52, 52>,
    <53, 53, 53>,
    <54, 54, 54>,
    <55, 55, 55>,
    <56, 56, 56>,
    <57, 57, 57>,
    <58, 58, 58>,
    <59, 59, 59>,
    <60, 60, 60>,
    <61, 61, 61>,
    <62, 62, 62>,
    <63, 63, 63>,
    <64, 64, 64>,
    <65, 65, 65>,
    <66, 66, 66>,
    <67, 67, 67>,
    <68, 68, 68>,
    <69, 69, 69>,
    <70, 70, 70>,
    <71, 71, 71>,
    <72, 72, 72>,
    <73, 73, 73>,
    <74, 74, 74>,
    <75, 75, 75>,
    <76, 76, 76>,
    <77, 77, 77>,
    <78, 78, 78>,
    <79, 79, 79>,
    <80, 80, 80>,
    <81, 81, 81>,
    <82, 82, 82>,
    <83, 83, 83>,
    <84, 84, 84>,
    <85, 85, 85>,
    <86, 86, 86>,
    <87, 87, 87>,
    <88, 88, 88>,
    <89, 89, 89>,
    <90, 90, 90>,
    <91, 91, 91>
  }
  scale <0.95, 0.95, 2.0>
  rotate -90.0*y
  translate  <7.98, 0.95, 0.0>
}

#declare ADPC_TroncoPricipal = union {
  object { TransSweep001 }
  sphere { // Sphere005
    <0,0,0>,1
    scale <1.6, 0.8, 0.8>
    translate  <-5.279691, 0.923946, 0.0>
  }
  object { TMesh001 }
  sphere { // Sphere006
    <0,0,0>,1
    scale <3.0, 0.75, 0.75>
    rotate 10.606327*z
    translate  <7.517864, 1.141954, 0.0>
  }
  object { TMesh002 }   
  texture       {    
    ADPC_TexturaTronco
  }
}
#local TaperSweep003 = prism {
  conic_sweep
  linear_spline
  0.0,1.0
  7  // control points
  <-1.0, -1.0>,
  <1.0, -1.0>,
  <1.685544, -0.556656>,
  <1.0, 1.0>,
  <-1.0, 1.0>,
  <-1.685544, -0.536253>,
  <-1.0, -1.0>
  rotate <90,0,90>
  translate  <-0.118142, 0.0, -1.007566>
  scale <1.12, 0.1, 10.9>
  rotate <92.411667, -0.571374, -23.451532>
  translate  <0.132319, 0.0, 0.082464>
}
#declare ADPC_AlitaVertica = difference {
  object { TaperSweep003 }
  box { // Cube003
    <-1, -1, -1>, <1, 1, 1>
    scale 3.5
    translate  <3.0, 6.92, 0.0>
  }
  sphere { // Sphere001
    <0,0,0>,1
    scale <1.0, 2.0, 1.0>
    rotate <3.180573, 1.039155, -18.074913>
    translate  <0.093826, 3.585591, 0.209624> 
    material     {
      ADPC_Material1B
    }
  }
  rotate -3.34586*x
  translate  <7.06, 1.2, 0.0>
  texture       {    
    ADPC_TexturaTronco
  }
}
//
// Include file contains 'RotSweep001'
//
#include "ADPC_IN2"
#local RotSweep001 = object {
  ADPC_RotSweep001_Raw
  scale <0.25, 0.25, 1.0>
  rotate -90.0*y
  translate  <6.850074, 2.3795, 0.0>
}
#local RotSweep002 = lathe {
  linear_spline
  4  // control points
  <0.347689, -0.883516>,
  <1.347689, -0.383516>,
  <1.347689, 0.616484>,
  <1.652311, 0.976703>
  rotate <90,0,90>
  material {
    ADPC_Material2
  }
  scale <0.3, 0.3, 1.2>
  rotate -90.0*y
  translate  <6.894478, 2.375658, -0.001666>
}
#declare ADPC_CorrienteMotor = union {
  object { RotSweep001 }
  object { RotSweep002 }
  disc   {
    0,     -x, 0.4 
    texture     {
      ADPC_AireCentral     
    }  
    translate   +6.0*x+2.37*y
  }
  translate  0.144212*x
}
#declare ADPC_AleronInteriorIzquierdo = union {
  box { // Cube022
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.480084, -0.99655, -3.747122>
  }
  sphere { // Sphere002
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere003
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.516764, -1.034947, -2.43712>
  }
  sphere { // Sphere004
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.809568, -1.034947, -3.256973>
  }
  rotate 3.267303*x
  texture       {
    ADPC_TexturaAleron
  }
  translate  <-3.162289, 1.34627, 1.512718>
}
#declare ADPC_AleronInteriorDerecho = union {
  box { // Cube024
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere007
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <7.122611, -1.034037, -4.000477>
  }
  sphere { // Sphere008
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.516764, -1.034947, -2.43712>
  }
  sphere { // Sphere009
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.809568, -1.034947, -3.256973>
  }
  scale -1.0
  rotate <2.929422, 0.0, -180.0>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <-3.162289, 1.323832, -1.346901>
}
#declare ADPC_AleronIzquierdo2 = union {
  box { // Cube026
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere010
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere011
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.516764, -1.034947, -2.43712>
  }
  sphere { // Sphere012
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.809568, -1.034947, -3.256973>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <0.8, 1.0, 0.8>
  rotate <135.431137, -83.134407, -131.65419>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <5.773784, 1.34627, -4.38845>
}
#declare ADPC_AleronIzquierdo3 = union {
  box { // Cube027
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere013
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere014
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.516764, -1.034947, -2.43712>
  }
  sphere { // Sphere015
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.809568, -1.034947, -3.256973>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <0.8, 1.0, 0.8>
  rotate <135.431137, -83.134407, -131.65419>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <6.399309, 1.38927, -5.775221>
}
#declare ADPC_AleronIzquierdo4 = union {
  box { // Cube028
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere016
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere017
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.516764, -1.034947, -2.43712>
  }
  sphere { // Sphere018
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.809568, -1.034947, -3.256973>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <0.8, 1.0, 0.7>
  rotate <135.431137, -83.134407, -131.65419>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <7.024834, 1.518271, -7.290993>
}
#declare ADPC_AleronDerecho2 = union {
  box { // Cube029
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere019
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere020
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.269443, -1.064245, -2.39767>
  }
  sphere { // Sphere021
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.439661, -1.076163, -3.109021>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <-0.8, -1.0, -1.0>
  rotate <-135.431137, 83.134407, 48.34581>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <2.556798, 1.131268, 2.349884>
}
#declare ADPC_AleronDerecho3 = union {
  box { // Cube030
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere022
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere023
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.235044, -1.063664, -2.344555>
  }
  sphere { // Sphere024
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.509178, -1.064794, -3.11545>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <-0.75, -1.0, -0.8>
  rotate <-97.194023, 85.463554, 86.26757>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <3.897208, 1.217269, 4.032981>
}
#declare ADPC_AleronDerecho4 = union {
  box { // Cube031
    <-1, -1, -1>, <1, 1, 1>
    rotate <0.0, 14.142346, 0.0>
    translate  <0.824515, 0.0, 0.396161>
    scale <0.4, 0.075, 0.920928>
    rotate -26.745226*y
    translate  <6.515706, -0.993504, -3.693776>
  }
  sphere { // Sphere025
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.92669, -1.034947, -4.018264>
  }
  sphere { // Sphere026
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.162145, -1.070494, -2.422826>
  }
  sphere { // Sphere027
    <0,0,0>,1
    scale <0.6, 0.05, 0.03>
    translate  <6.4321, -1.07235, -3.217966>
  }
  rotate <-34.978031, 84.24662, -32.970497>
  translate  <4.033706, 0.900334, 8.616666>
  scale <0.8, 1.0, -0.7>
  rotate <74.627357, -85.543411, -71.296196>
  texture       {
    ADPC_TexturaAleron
  }
  translate  <4.701455, 1.303269, 5.345149>
}
#declare ADPC_LlantasMedio = union {
  torus { // Torus001
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.710741, 9.432299, 7.708243>  
  }
  torus { // Torus002
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.702646, 9.432299, 7.918718>
  }
  torus { // Torus003
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.108852, 9.443106, 7.684959>
  }
  torus { // Torus004
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.108852, 9.432299, 7.907076>
  }
  box { // Cube032
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.86478, 7.829798>
  }
  cylinder { // Cylndr002
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 1.0>
    rotate -90.0*x
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.404637, 9.42787, 7.803149>
  }
  cylinder { // Cylndr003
    <0,0,1>, <0,0,0>, 1 
    scale <0.05, 0.05, 1.0>
    rotate -90.0*y
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <0.090214, 9.429912, 7.798512>
  }
  cylinder { // Cylndr004
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 0.2>
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.093181, 9.43522, 7.678452>
  }
  cylinder { // Cylndr005
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 0.2>
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.686922, 9.43522, 7.72502>
  }
  box { // Cube033
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    rotate -41.677639*z
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.719143, 7.829798>
  }
  translate  <-0.294684, -9.991123, -7.810247>
}
#declare ADPC_LlantasTraseras = union {
  torus { // Torus005
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.710741, 9.432299, 7.708243>
  }
  torus { // Torus006
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.702646, 9.432299, 7.918718>
  }
  torus { // Torus007
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.105358, 9.432299, 7.684959>
  }
  torus { // Torus008
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.108905, 9.432299, 7.907076>
  }
  box { // Cube034
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.86478, 7.829798>
  }
  cylinder { // Cylndr006
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 1.0>
    rotate -90.0*x
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.404637, 9.42787, 7.803149> 
  }
  cylinder { // Cylndr007
    <0,0,1>, <0,0,0>, 1 
    scale <0.05, 0.05, 1.0>
    rotate -90.0*y
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <0.090214, 9.429912, 7.798512>
  }
  cylinder { // Cylndr008
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 0.2>
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.093181, 9.43522, 7.678452>
  }
  cylinder { // Cylndr009
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 0.2>
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.686922, 9.43522, 7.72502>
  }
  box { // Cube035
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    rotate -41.677639*z
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.719143, 7.829798>
  }
  translate  <7.555702, -9.834842, -7.78386> 
}
#declare ADPC_LlantasDelanteras = union {
  torus { // Torus009
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.407446, 9.432299, 7.708243>
  }
  torus { // Torus010
    1.5, 0.5  rotate -x*90
    scale 0.1
    texture     {
      ADPC_TexturaLlanta
    }
    translate  <-0.421014, 9.432299, 7.918718>
  }
  box { // Cube036
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.86478, 7.829798>
  }
  cylinder { // Cylndr010
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 1.0>
    rotate -90.0*x
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.404637, 9.42787, 7.803149>
  }
  cylinder { // Cylndr013
    <0,0,1>, <0,0,0>, 1 
    scale <0.1, 0.1, 0.2>
    texture     {
      ADPC_TexturaSoporteLlanta
    }
    translate  <-0.40529, 9.413556, 7.72502>
  }
  box { // Cube037
    <-1, -1, -1>, <1, 1, 1>
    scale <0.221823, -0.044664, 0.015074>
    rotate -41.677639*z
    texture     {
      ADPC_TexturaSoporteLlanta2
    }
    translate  <-0.40738, 9.719143, 7.829798>
  }
  translate  <-4.037103, -10.036079, -7.859765>
}
#local Puertecilla = difference {
  cylinder { // Cylndr011
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr012
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube040
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, 0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.047654, 9.690102>
}
#local Puertecilla1 = difference {
  cylinder { // Cylndr018
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr019
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube041
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, -0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.039269, 10.34482>
}
#declare ADPC_PuertecillasMedio = union {
  object { Puertecilla }
  object { Puertecilla1 }
  translate  <0.091893, -10.197252, -9.928006>
}
#local Puertecilla2 = difference {
  cylinder { // Cylndr014
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr015
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube042
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, 0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.047654, 9.690102>
}
#local Puertecilla3 = difference {
  cylinder { // Cylndr020
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr021
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube043
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, -0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.039269, 10.34482>
}
#declare ADPC_PuertecillasTrasera = union {
  object { Puertecilla2 }
  object { Puertecilla3 }
  rotate <0.0, -0.0, -6.654425>
  translate  <-0.434244, -10.079749, 0.0>
  //rotate 16.106503*z
  translate  <6.71307, 0.07665, -9.995003> 
  translate     +0.4*x+0.1*y
}
#local Puertecilla4 = difference {
  cylinder { // Cylndr016
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr017
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube044
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, 0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.047654, 9.690102>
}
#local Puertecilla5 = difference {
  cylinder { // Cylndr022
    <0,0,1>, <0,0,0>, 1 
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.667052>
  }
  cylinder { // Cylndr023
    <0,0,1>, <0,0,0>, 1 
    scale <0.9, 0.9, 1.5>
    rotate -0.0*x
    translate  <0.0, 1.544022, 3.567052>
  }
  box { // Cube045
    <-1, -1, -1>, <1, 1, 1>
    scale 1.355248
    rotate -0.0*x
    translate  <0.0, 0.772011, 4.149559>
  }
  rotate -0.0*x
  translate  <0.0, -2.026529, -3.281046>
  scale <0.2, -0.2, 0.6>
  rotate <-90.0, -1.935705, 90.0>
  translate  <-0.228091, 10.039269, 10.34482>
}
#declare ADPC_PuertecillasDelanteras = union {
  object { Puertecilla4 }
  object { Puertecilla5 }
  translate  <-3.696293, -9.974576, -9.995003> 
  translate     -0.2*y
}   
#macro ADPC_AvionDouglas( AnguloI1, AnguloI2, AnguloI3, AnguloI4, 
                          AnguloD1, AnguloD2, AnguloD3, AnguloD4 )
union { // CuerpoAvion
  object { // BaseAla1 -> BaseAla
    ADPC_BaseAla
    scale -1.0
    rotate 180.0*z
  }
  object { ADPC_BaseAla }
  object { ADPC_TroncoPricipal }
  object { ADPC_AlaTrasera }
  object { // AlaTrasera1 -> AlaTrasera
    ADPC_AlaTrasera
    scale -1.0
    rotate -180.0*z
    translate  -0.0*x
  }
  object { ADPC_AlitaVertica }
  object { ADPC_CorrienteMotor }
  object { 
    ADPC_AleronInteriorIzquierdo 
    #local P1   = < 2.7, 0.5, -1.2 >;
    #local P2   = < 3.4, 0.5, -2.6 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, -AnguloI1 )
    translate   +P1
  }
  object { 
    ADPC_AleronInteriorDerecho 
    #local P1   = < 2.7, 0.5, +1.2 >;
    #local P2   = < 3.4, 0.5, +2.6 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, +AnguloD1 )
    translate   +P1
  }
  object { 
    ADPC_AleronIzquierdo2
    #local P1   = < 3.6, 0.5, -2.8 >;
    #local P2   = < 4.2, 0.7, -4.0 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, -AnguloI2 )
    translate   +P1
  }
  object { 
    ADPC_AleronIzquierdo3
    #local P1   = < 4.6, 0.6, -4.3 >;
    #local P2   = < 5.2, 0.7, -5.6 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, -AnguloI3 )
    translate   +P1
  }
  object { 
    ADPC_AleronIzquierdo4
    #local P1   = < 5.2, 0.7, -5.9 >;
    #local P2   = < 5.7, 0.8, -6.7 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, -AnguloI4 )
    translate   +P1
  }
  object { 
    ADPC_AleronDerecho2
    #local P1   = < 3.6, 0.5, +2.8 >;
    #local P2   = < 4.2, 0.7, +4.0 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, +AnguloD2 )
    translate   +P1
  }
  object { 
    ADPC_AleronDerecho3
    #local P1   = < 4.6, 0.6, +4.3 >;
    #local P2   = < 5.2, 0.7, +5.6 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, -AnguloD3 )
    translate   +P1
  }
  object { 
    ADPC_AleronDerecho4
    #local P1   = < 5.2, 0.7, +5.9 >;
    #local P2   = < 5.7, 0.8, +6.7 >;
    translate   -P1
    Axis_Rotate_Trans( P2-P1, +AnguloD4 )
    translate   +P1
  } 
  #if ( ADPC_BanderaRueda )
    object { ADPC_LlantasMedio }
    object { ADPC_LlantasTraseras 
      translate -0.25*y-1.5*x      
    }
    object { ADPC_LlantasDelanteras } 
    object { ADPC_PuertecillasMedio }
    object { ADPC_PuertecillasTrasera 
      translate -0.25*y-1.5*x      
    }
    object { ADPC_PuertecillasDelanteras }
  #end
  material {
    ADPC_Material1
  }
  translate  <0.0, 0.023383, 0.023383>
  scale 1/15
  scale 1/1.15*40.750
}
#end



