// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 agosto 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// APUD AnteojoPersonalUsoDiario
// El archivo dibuja un anteojo simple
// En su estructura posee algunos defectos,
// sera necesario cuidar el angulo de presentacion.
// #macro APUD_Anteojo( FraccionDerecha, FraccionIzquierda )
//      FraccionDerecha         : Fraccion entre 0.0 (abierto) y
//              1.0 (cerrado) de la pata derecha respecto del dueo.
//              Probablemente requiera valores negativos.
//      FraccionIzquierda       : Fraccion entre 0.0 (abierto) y
//              1.0 (cerrado) de la pata izquierda respecto del dueo.
//              Probablemente requiera valores negativos.
// Las caracteristicas del anteojo son las siguientes.
// El anteojo cerrado esta parcialmente centrado en el origen.
// El vidrio sobresale hacia z-.
// La linea imaginaria que une el soporte de las patas y de los aros,
// se encuentra en el plano XY.  Al abrirse, las patas se
// abren hacia z+.
// Cuando el anteojo esta cerrado :
// Min < -52.5, -26.0, -5.00 >*L
// Max < +52.5, +6.50, +11.0 >*L
// Cuando el anteojo esta abierto :
// Min < -47.5, -26.0, -5.00 >*L
// Max < +47.5, +6.50,  +110 >*L
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare APUD_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare APUD_DefaultTexturaAro      = texture { ... }
//      Permite modificar la textura de los aros.
// #declare APUD_DefaultTexturaCuero    = texture { ... }
//      Permite modificar la textura final de las patas del anteojo.
// #declare APUD_DefaultTexturaMetal    = texture { ... }
//      Permite modificar la textura a aplicar en el tornillo de giro.
// #declare APUD_DefaultTexturaPlastico = texture { ... }
//      Permite modificar la textura a aplicar en el soporte de nariz.
// #declare APUD_DefaultTexturaPata     = texture { ... }
//      Permite modificar la textura a aplicar en la pata y
//      soporte central.
//
// Para colocarlo simplemente
// #include "APUD.inc"
// object { APUD_Anteojo( 1.0, 1.0 ) }
//
// Otro ejemplo con modificador
// #include "APUD.inc"
// #declare APUD_DefaultTexturaPata             = texture       {
//   PinkAlabaster
// }
// #declare APUD_DefaultTexturaAro              = texture       {
//   pigment    { Pink }
// }
// object       { APUD_Anteojo( 0.0, 0.0 ) }
//

#include "textures.inc"
#include "colors.inc"
#include "woods.inc"
#include "APUD_AUX.pov"

#declare APUD_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( APUD_POV3_1 )
    #declare APUD_POV3_1        = on;
  #end
#else
  #ifndef( APUD_POV3_1 )
    #declare APUD_POV3_1        = off;
  #end
#end

#declare APUD_MaterialAnteojo   = 
material        {
  texture       {
    pigment     {rgbf <0.98,1.0,0.96,0.9>}
    normal      { bumps 10 scale 0.1 }
  }
  interior      {
    ior 1.6
  } 
}

#ifndef ( APUD_DefaultMaterialAnteojo )
  #declare APUD_DefaultMaterialAnteojo  = material      {
    APUD_MaterialAnteojo
  }
#end

#declare APUD_TexturaAro                = texture       {
  T_Wood22
  scale         0.01
}

#ifndef ( APUD_DefaultTexturaAro )
  #declare APUD_DefaultTexturaAro       = texture       {
    APUD_TexturaAro
  }
#end

#declare APUD_TexturaMetal              = texture       {
  pigment       {
    Gold/2
  }
}

#ifndef ( APUD_DefaultTexturaMetal )
  #declare APUD_DefaultTexturaMetal     = texture       {
    APUD_TexturaMetal
  }
#end

#declare APUD_TexturaCuero              = texture       {
  pigment { Gray10 }
}

#ifndef ( APUD_DefaultTexturaCuero )
  #declare APUD_DefaultTexturaCuero     = texture       {
    APUD_TexturaCuero
  }
#end

#declare APUD_TexturaPlastico   = texture       {
  pigment { Gold/2 }
}

#ifndef ( APUD_DefaultTexturaPlastico )
  #declare APUD_DefaultTexturaPlastico  = texture       {
    APUD_TexturaPlastico
  }
#end

#ifndef ( APUD_DefaultTexturaPata )
  #declare APUD_DefaultTexturaPata      = texture       {
    APUD_TexturaAro
  }
#end

#ifndef ( APDU_MatrizBase )
  #declare APUD_TotalPuntosMatrizBase   = 14;
  #declare APUD_MatrizBase              = array[ APUD_TotalPuntosMatrizBase ]
        {  
          < 0.101,-0.40,-0.03 >,
          < 0.00, 0.00,-0.00 >,
          < 0.101, 0.15,-0.03 >,
          < 0.20, 0.18,-0.06 >,
          < 0.501, 0.20,-0.08 >,
          < 0.801, 0.15,-0.05 >,
          < 1.00, 0.00,-0.00 >,
          < 1.021,-0.28,-0.03 >,
          < 0.90,-0.45,-0.05 >,
          < 0.80,-0.50,-0.07 >,
          < 0.501,-0.54,-0.08 >,
          < 0.20,-0.48,-0.05 >,
          < 0.101,-0.40,-0.03 >,
          < 0.00, 0.00,-0.00 >
        }
   #declare APUD_PuntoAlto              = < 0.6,-0.10,-0.12>;
 //  < 0.5,-0.2,-0.15 >;
#end

#macro APUD_Vidrio( MatrizBase, PuntoAlto, Largo, Grueso, MaterialVidrio )
  merge         {
    #local C                    = 0;
    #local TotalCiclos          = dimension_size( MatrizBase, 1 )-2;
    #while ( C < TotalCiclos )
      object            {
        APUD_TrianguloEsfericoTriplePunto(
          MatrizBase[ C+1 ]*Largo,
          PuntoAlto*Largo,
          MatrizBase[ C+2 ]*Largo,
          1.0*Largo, Grueso, true
        )
      }
      #local C                  = C+1;
    #end
    material            {
      MaterialVidrio
    }
  }
#end

#macro APUD_SoporteVidrio
        ( MatrizBase, PuntoAlto, Largo,
                AnchoSoporte, GruesoSoporte, TexturaSoporte )
  union         {
    #local C                    = 0;
    #local TotalCiclos          = dimension_size( MatrizBase, 1 )-2;
    #local PuntoPivote          = <0,0,0>;
    #while ( C < TotalCiclos )
        object          {
          APUD_AnilloTriplePunto
                ( MatrizBase[ C ]*Largo, MatrizBase[ C+1 ]*Largo,
                  MatrizBase[ C+2 ]*Largo,
                  AnchoSoporte, GruesoSoporte, false )
        }
      #local C                  = C+1;
    #end
    texture             {
      TexturaSoporte
    }
  }
#end


#macro APUD_AnteojoPersonalUsoDiario
        ( Angulo1, Angulo2, LargoFrontal, SeparacionOjos, LargoLateral,
                AnchoPata, GruesoPata,
          MatrizBase, PuntoAlto, LargoVidrio, GruesoVidrio,
                AnchoSoporte, GruesoSoporte, MaterialVidrio, TexturaSoporte,
          TexturaSecundaria, TexturaMetal, TexturaCuero, TexturaPlastico
        )
  #local MyAroBase      = union {
    APUD_Vidrio( MatrizBase, PuntoAlto, LargoVidrio,
                GruesoVidrio, MaterialVidrio )
    APUD_SoporteVidrio( APUD_MatrizBase, APUD_PuntoAlto, LargoVidrio,
                AnchoSoporte, GruesoSoporte,
                TexturaSoporte )
  }
  #local MyFinalBase    = union {
    #local PivoteA      = ( SeparacionOjos+LargoVidrio )/2*x+0.001*L*z;
    #local PivoteC      = LargoFrontal/2*x+0.1*LargoLateral*z+0.001*L*y;
    #local PivoteB      = 0.4*LargoFrontal/2*x
                                +0.6*( 0.3*PivoteA+0.7*PivoteC );
    object      {
      APUD_AnilloTriplePunto
                ( PivoteA, PivoteB,
                  PivoteC,
                  GruesoPata, AnchoPata, false )
    }
    cylinder    {
      PivoteC-AnchoPata/2*y-GruesoPata*x-GruesoPata/3*z,
      PivoteC+AnchoPata/2*y-GruesoPata*x-GruesoPata/3*z,
      GruesoPata/2
      texture   {
        TexturaMetal
      }
    }
    texture     {
      TexturaSecundaria
    }
  }
  #local PataMovil      = union {
    box         {
      -AnchoPata/2*y,
      +AnchoPata/2*y+0.7*LargoLateral*z+GruesoPata*x
    }
    prism       {
      cubic_spline
      -0.1*GruesoPata,
      1.1*GruesoPata,
      10,
      < 0.55*AnchoPata, 0 >,
      <-0.55*AnchoPata, 0 >,
      <-0.25*AnchoPata,+0.1*LargoLateral>,
      <+0.5*LargoVidrio,+0.3*LargoLateral>-<0.1*LargoVidrio,-0.15*AnchoPata>,
      <+0.5*LargoVidrio,+0.3*LargoLateral>,
      <+0.5*LargoVidrio,+0.3*LargoLateral>-<0.1*LargoVidrio,0.75*AnchoPata>,
      < 0.85*AnchoPata,+0.1*LargoLateral>,
      < 0.55*AnchoPata, 0 >,
      <-0.55*AnchoPata, 0 >,
      <-0.55*AnchoPata,+0.1*LargoLateral>
      rotate    -90*z
      translate 0.7*LargoLateral*z
      texture   {
        TexturaCuero
      }
    }
    texture     {
      TexturaSecundaria
    }
  }
  union         {
    object      {
      MyAroBase
      translate         ( SeparacionOjos-LargoVidrio )*x/2
    }
    object      {
      MyAroBase
      translate         ( SeparacionOjos-LargoVidrio )*x/2
      scale     <-1,1,1>
    }
    #local PivoteA    = ( SeparacionOjos-LargoVidrio )*x/2;
    #local PivoteB    = -0.1*LargoVidrio*z-0.01*L*x-0.01*L*y;
    #local PivoteC    = PivoteA*<-1,1,1>+0.01*PivoteB;
    object      {
      APUD_AnilloTriplePunto
                ( PivoteA, PivoteB,
                  PivoteC,
                  0.5*GruesoPata, 1.5*AnchoPata, false )
      texture   {
        TexturaSecundaria
      }
    }
    sphere      {
      0 , 1
      scale     <GruesoPata/2,2*AnchoPata,GruesoPata/2>
      rotate    5*z
      translate PivoteA+GruesoPata*z-1.5*AnchoPata*y
      texture   {
        TexturaMetal
      }
    }
    sphere      {
      0 , 1
      scale     <GruesoPata/2,2*AnchoPata,GruesoPata/2>
      rotate    5*z
      translate PivoteA+GruesoPata*z-1.5*AnchoPata*y
      scale     <-1,1,1>
      texture   {
        TexturaMetal
      }
    }
    object      {
      MyFinalBase
    }
    object      {
      MyFinalBase
      scale     <-1,1,1>
    }
    object      {
      PataMovil
      rotate    5*x
      rotate      -Angulo1*y
      translate   ( LargoFrontal/2-GruesoPata/2 )*x+0.1*LargoLateral*z
    }
    object      {
      PataMovil
      scale     <-1,1,1>
      rotate    5*x
      rotate      Angulo2*y
      translate   -( LargoFrontal/2-GruesoPata/2 )*x+0.1*LargoLateral*z
    }
  }
#end


#macro APUD_Anteojo( FraccionDerecha, FraccionIzquierda )
  #local L                      = APUD_L;
  #local LargoAnteojo           = 35*L;
  #local GruesoAnteojo          = 1.5*L;
  #local LargoFrontal           = 96*L;
  #local SeparacionOjos         = 50*L;
  #local LargoLateral           = 100*L;
  #local AnchoPata              = 3.0*L;
  #local GruesoPata             = 1.6*L;
  object        {
    APUD_AnteojoPersonalUsoDiario( 
                95*FraccionIzquierda, 95*FraccionDerecha,
                LargoFrontal, SeparacionOjos, LargoLateral,
                AnchoPata, GruesoPata,
                APUD_MatrizBase, APUD_PuntoAlto, LargoAnteojo,
                GruesoAnteojo,
                1.2*GruesoAnteojo, 1.2*GruesoAnteojo,
                APUD_DefaultMaterialAnteojo, APUD_DefaultTexturaAro,
                APUD_DefaultTexturaPata,
                APUD_DefaultTexturaMetal,
                APUD_DefaultTexturaCuero,
                APUD_DefaultTexturaPlastico )
  }
#end
