// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// EJNN ExprimidorJugosNaranjaNatural
// El archivo dibuja un exprimidor de jugos
// en posicion default con la macro
// NOTA : Es importante ajustar la variable
// global max_trace_level, de lo contrario
// se veran zonas negras muy desagradables
// #macro EJNN_ExprimidorJugosNaranjaNatural( BanderaExprimidor )
//      BanderaExprimidor       : true se dibuja un exprimidor de jugos
//                                false elimina los elementos peculiares
//                                del exprimidor, para adaptarse
//                                a otros usos
// Las caracteristicas serian
//      Altura Pichel sin tapa  : 75*L
//      Altura Base             : 37.5*L
//      Altura Total con tapa   : 134.5*L
//      Radio principal         : 58*L (sin agarradera)
// La base del pichel se encuentra sobre el plano XY,
// La tapa hacia Y+, y la base hacia Y-
// La boquilla hacia X-, y la agarradera hacia X+
//
// Los elementos del exprimidor se pueden dibujar con
// macros independientes, que los coloca
// en la misma posicion del dibujo inicial
//
// El pichel sin tapa puede dibujarse con
// #macro EJNN_Pichel( Diametro, Alto, DiametroInterior,
//                TexturaTransparente, BanderaExprimidor )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroInterior        : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota inferior
//      TexturaTransparente     : Textura a aplicar al pichel
//      BanderaExprimidor       : true lo dibuja como exprimidor
//                                false lo dibuja como pichel comun
//
// La tapa del pichel, se dibuja con la siguiente macro,
// se coloca en la misma posicion que el dibujo...
// #macro EJNN_TapaPichel( Diametro, Alto, TexturaTransparente )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//                                (del pichel NO la tapa)
//      TexturaTransparente     : Textura a aplicar al pichel
//
// La base solo bajo el plano XY se dibuja con...
// #macro EJNN_BasePichel( Diametro, Alto, DiametroGiro, AltoBase,
//             TexturaBase, TexturaBarata, TexturaPatita, BanderaExprimidor )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroGiro            : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota superior
//      AltoBase                : Alto total de la base
//      TexturaBase             : Textura a aplicar a la base
//      TexturaBarata           : Textura a aplicar al soporte
//                                superior de giro
//      TexturaPatita           : Textura a aplicar a las patitas
//                                cilindricas inferiores
//      BanderaExprimidor       : true lo dibuja como exprimidor
//                                false lo dibuja como base simple
//
// #macro EJNN_FiltroJugo( Diametro, Alto, DiametroFiltro,
//                        DiametroGiro, TexturaFiltroJugo )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroFiltro          : Aproxima el diametro del filtro
//                                de rotacion
//      DiametroGiro            : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota superior
//      TexturaFiltroJugo       : Textura a aplicar al filtro de rotacion
//
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare EJNN_VolumenJugo            = Sirve para agregar jugo
//      al pichel.  Se genera automaticamente con las macros de pichel
//      intersection { object { EJNN_VolumenJugo } object{ ... } }
// #declare EJNN_TexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel y la tapa
// #declare EJNN_TexturaBase            = texture { ... }
//      Textura a aplicar a la base
// #declare EJNN_TexturaBarata          = texture { ... }
//      Textura a aplicar al extremo superior del cilindro de giro
// #declare EJNN_TexturaFiltroJugo      = texture { ... }
//      Textura a aplicar al filtro de giro
// #declare EJNN_TexturaPatita          = texture { ... }
//      Textura a aplicar a las patitas negras cilindricas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare GSCA_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare EJNN_TexturaTransparente            = texture { ... }
//      Textura a aplicar al pichel y la tapa
// #declare EJNN_DefaultTexturaBase             = texture { ... }
//      Textura a aplicar a la base
// #declare EJNN_DefaultTexturaBarata           = texture { ... }
//      Textura a aplicar al extremo superior del cilindro de giro
// #declare EJNN_DefaultTexturaFiltroJugo       = texture { ... }
//      Textura a aplicar al filtro de giro
// #declare EJNN_DefaultTexturaPatita           = texture { ... }
//      Textura a aplicar a las patitas negras cilindricas
//
// Para colocarlo simplemente
// #include "EJNN.inc"
// object { EJNN_ExprimidorJugosNaranjaNatural( true ) }
//
// Otro ejemplo con modificador
// #include "EJNN.inc"
// #declare EJNN_DefaultTexturaBase             = texture       {
//   PinkAlabaster
// }
// #declare EJNN_DefaultTexturaTransparente     = texture       {
//   average
//   texture_map        {
//     [ 0.5 EJNN_TexturaTransparente   ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// union                {
//   object       { EJNN_ExprimidorJugosNaranjaNatural( false ) }
//   intersection       {
//     cylinder { 0, 20*L*y, 100*L }
//     object   { EJNN_VolumenJugo }
//     pigment  { Orange           }
//   }
// }
//

global_settings {
  max_trace_level       20
}

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "EJNN.inc"

#local FactorAcercamiento       = 8;

object          {
  EJNN_ExprimidorJugosNaranjaNatural( true )  
  translate     -20*L*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}
