// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 junio 2011
//
// ADVERTENCIA: (todas las fuentes son legtimas y de libre uso comercial)
// Las macros EMBA_Reorient_Trans y EMBA_Axis_Rotate_Trans
// se transcribe casi identica a la original
// en "transforms.inc" Reorient_Trans y Axis_Rotate_Trans
// se copia por compatibilidad con POVRay 3.1.
// La macro EMBA_VPerp_To_Vector
// se tomo de "math.inc" VPerp_To_Vector
// por compatibilidad con POVRay 3.1.
// Otras fuentes:
// link_object (el elemento base de la cadena) fue transcrito
// con pocas modificaciones del archivo
// "fireplug.inc"
// Tomado de la Biblioteca de POVRAY administrada por Micha Riser
// autor Christophe Bouffartigue de fecha 3 Julio 2000
// email: christophe.bouffartigue@libertysurf.fr
// ademas se llama a "link.inc"
// "link.inc"
// Created by Chris Colefax, 20 April 1998
// archivo especializado para generar cadenas...
// puede obtenerse junto con "fireplug.inc" en la misma fuente
// FIN ADVERTENCIA
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// La macro EMBA_Escalera()
// Crea una escalera domestica parte alta orientada hacia y+,
// el centro de la base reposando cercano al origen.
// Las patas alineadas sobre el eje x.
// El frente en x+, y la base alta atravezada en su centro por el eje y.
// Altura Escalera      : 682*L
// Ancho Escalera       : 264*L
//      sin contar las cadenas de grosor 7*L cada una
// Profundidad Escalera : +296*L ( frente x+ )
//                        -234*L aprox    x-
// Plataforma Superior  : 144*L centrada en x
//
// El objeto puede generarse via una macro principal de texturas
// #macro EMBA_EscaleraMaderaBajaAltura
//        ( FraccionGiro, NumeroEscalones, FraccionGrada,
//              TexturaMadera, TexturaMaderaBarata, TexturaMetalica )
//      FraccionGiro            : permite abrir con 1.0 o cerrar 0.0 la
//              escalera, con sus fracciones.
//              La escalera se cierra paulatinamente, en forma
//              vertical utilizando de apoyo la pata delantera.
//      NumeroEscalones         : cambia el total de escalones.
//      FraccionGrada           : valor default es 1.0.  Permite cambiar
//              el ancho de la madera de los escalones.
//              Puede ser util si se quiere poner un elevado numero
//              de escalones.
//      TexturaMadera           : textura principal a aplicar a la estructura.
//      TexturaMaderaBarata     : textura a aplicar en las barras cruzadas
//              que soportan las patas moviles.
//      TexturaMetalica         : textura a aplicar en las cadenas y en
//              sujetadores metalicos de la escalera.
//
// Las siguientes variables no deberian modificarse
// EMBA_Escalones               = array [ NumeroEscalones+1 ]
//      Arreglo de vectores 3D con la ubicacin de la parte central
//      superior de las gradas.  EMBA_Escalones[ 0 ], es la base
//      superior.  El resto se numera desde abajo hacia arriba.
// EMBA_TexturaMadera
//      Define una textura principal a aplicar en la estructura.
// EMBA_TexturaMaderaBarata
//      Otra textura para aplicar en las barras cruzadas de soporte.
// EMBA_TexturaMetalica
//      Textura para aplicar en las zonas metalicas de la escalera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EMBA_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare EMBA_Link           = off;
//      Al activarse dibuja la cadena.  Por default no la dibuja.
//      El problema es la disponibilidad del archivo
//      "link.inc" de Chris Colefax, que no es compatible
//      con el nuevo standard de la biblioteca POV-Ray.
//      Puede conseguirse en la Biblioteca administrada
//      por Micha Riser.  Objeto "fireplug.inc".
// #declare EMBA_DefaultTexturaMadera           = texture ...
//      Define una textura default principal para aplicar a la escalera.
// #declare EMBA_DefaultTexturaMaderaBarata     = texture ...
//      Otra textura default para aplicar en las barras cruzadas de soporte.
// #declare EMBA_DefaultTexturaMetalica         = texture ...
//      Textura default de las estructuras metalicas.
//
// Para colocarlo simplemente
// #include "EMBA.inc"
// object { EMBA_Escalera() }
//
// Si dispone del archivo "link.inc", puede dibujar la cadena con:
// #declare EMBA_Link                   = on;
// #include "EMBA.inc"
// object { EMBA_Escalera() }
//
// Para el uso de la macro de texturas:
// #include "EMBA.inc"
// object {
//   EMBA_EscaleraMaderaBajaAltura( 0.0, 9, 0.3,
//      EMBA_DefaultTexturaMadera,
//      EMBA_DefaultTexturaMaderaBarata,
//      EMBA_DefaultTexturaMetalica )
// }
//
// Otro ejemplo con modificador
// #include "EMBA.inc"
// #declare EMBA_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.5 RCPS_Rust                          ]
//     [ 0.5 RCPS_TexturaMetalica               ]
//   }
// }
// union        {
//   object       { EMBA_Escalera() }
//   sphere       { EMBA_Escalones[ 0 ]+0.03*y, 0.03 pigment { Blue } }
// }
//

#include "woods.inc"
#include "metals.inc"
#include "EMBA_Aux.inc"

#declare EMBA_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( EMBA_POV3_1 )
    #declare EMBA_POV3_1        = on;
  #end
#else
  #ifndef( EMBA_POV3_1 )
    #declare EMBA_POV3_1        = off;
  #end
#end

#ifndef ( EMBA_Link )
  #declare EMBA_Link            = off;
#end

#declare EMBA_TexturaMadera                     = texture       {
  T_Wood20
}

#declare EMBA_DefaultTexturaMadera              = texture       {
  EMBA_TexturaMadera
}

#declare EMBA_TexturaMaderaBarata               = texture       {
  T_Wood18
}

#declare EMBA_DefaultTexturaMaderaBarata        = texture       {
  EMBA_TexturaMaderaBarata
}

#declare EMBA_TexturaMetalica                   = texture       {
  T_Brass_3B
}

#declare EMBA_DefaultTexturaMetalica            = texture       {
  EMBA_TexturaMetalica
}

#macro EMBA_EscaleraMaderaBajaAltura
        ( FraccionGiro, NumeroEscalones, FraccionGrada
                TexturaMadera, TexturaMaderaBarata, TexturaMetalica )
  #local L                      = EMBA_L;
  // Base Alta
  #local GruesoBaseAlta         = 12*L*FraccionGrada;
  #local LargoBaseAlta          = 264*L;
  #local AnchoBaseAlta          = 144*L;
  #local AltitudBaseAlta        = 670*L;
  // Para Fija
  #local DesplazadoPataFija     = 296*L;
  #local GruesoPataFija         = 21*L;
  #local AnchoPataFija          = 58*L;
  #local GiroGuardar            = DesplazadoPataFija*x;
    // Calculo de Angulo de giro para cerrar escalera
  #local Pivote                 = DesplazadoPataFija-AnchoPataFija;
  #local Pivote2                =
                sqrt( Pivote*Pivote+AltitudBaseAlta*AltitudBaseAlta );
  #local AnguloGiroGuardar      = degrees( asin( Pivote/Pivote2 ) );
  #local TotalEscalones         = NumeroEscalones;
  #local GruesoEscalon          = 22*L*FraccionGrada;
        // Altitud del escalon por arriba
  #local AltitudEscalon         =
        ( AltitudBaseAlta-TotalEscalones*GruesoEscalon )/( TotalEscalones+1 )
                        +GruesoEscalon;
  #local AnchoEscalon           = 252*L;
  // Pata Movil
  #local GruesoPataMovil        = 14*L;
  #local AnchoPataMovil         = 45*L;
  #local AnguloPataMovil        = degrees( asin( 0.3 ) );
    // Reglas cruzadas soporte de pata movil
  #local AnguloCruz             =
        degrees( asin( 1.2*LargoBaseAlta/AltitudBaseAlta ) );
  #local PuntoGiro              =
                < -cos( radians( AnguloPataMovil ) ),
                  -sin( radians( AnguloPataMovil ) ), 0 >*AnchoPataMovil/2
                  +AltitudBaseAlta*y;
  union                 {
    // Base Alta
    box                 {
      < -AnchoBaseAlta/2        , AltitudBaseAlta       ,
        -LargoBaseAlta/2        >,
      < +AnchoBaseAlta/2        , AltitudBaseAlta+GruesoBaseAlta        ,
        +LargoBaseAlta/2        >
    }
    // Fin Base Alta
    // PataFija
    #local PataFija     =
      prism               {
        linear_spline
        -GruesoPataFija/2       , +GruesoPataFija/2     ,
        5,
        < +DesplazadoPataFija   , 0                     >,
        < +DesplazadoPataFija-AnchoPataFija, 0          >,
        < 0     , AltitudBaseAlta                       >,
        < +AnchoPataFija        , AltitudBaseAlta       >,
        < +DesplazadoPataFija   , 0                     >
        rotate                  -90*x
      }
    // Fin declare PataFija
    union               {
      difference        {
        union           {
          object              {
            PataFija
            translate         +( LargoBaseAlta/2-GruesoPataFija/2 )*z
          }
          object              {
            PataFija
            translate         -( LargoBaseAlta/2-GruesoPataFija/2 )*z
          }
        }
        #local C        = 0;
        #while ( C < TotalEscalones )
          box             {
            < -AltitudBaseAlta, AltitudEscalon-GruesoEscalon,
                                -AnchoEscalon/2 >,
            < +AltitudBaseAlta, AltitudEscalon              ,
                                +AnchoEscalon/2 >
            translate     C*AltitudEscalon*y
          }
          #local C      = C+1;
        #end
      }
      #local C          = 0;
      #local DesplazadoEscalon                  =
        ( DesplazadoPataFija-AnchoPataFija )/( TotalEscalones+1 );
      #declare EMBA_Escalones   = array [ TotalEscalones+1 ]
      #declare EMBA_Escalones[ 0 ]      =
                        ( AltitudBaseAlta+GruesoBaseAlta )*y;
      #while ( C < TotalEscalones )
        box             {
          < +DesplazadoPataFija-DesplazadoEscalon-0.95*AnchoPataFija,
                        AltitudEscalon-GruesoEscalon,
                                -AnchoEscalon/2 >,
          < +DesplazadoPataFija-1.15*DesplazadoEscalon, AltitudEscalon,
                                +AnchoEscalon/2 >
          translate       C*AltitudEscalon*y-C*DesplazadoEscalon*x
        }
        #declare EMBA_Escalones[ C+1 ]          =
          < +DesplazadoPataFija-( C+1 )*DesplazadoEscalon-0.5*AnchoPataFija,
                        +( C+1 )*AltitudEscalon, 0 >;
        #local C        = C+1;
      #end
    }
    // Fin PataFija
    // PataMovil
    #local PataMovil    =
      union             {
        difference      {
          box           {
            < 0                 , 0                     ,
                -GruesoPataMovil/2                      >,
            < AnchoPataMovil    , -2*AltitudBaseAlta    ,
                +GruesoPataMovil/2                      >
            rotate      -AnguloPataMovil*z
            translate   -AnchoPataMovil*x+AltitudBaseAlta*y
          }
          plane         {
            y           , 0
          }
        }
        object          {
          #local SegmentoP      = 0*x;
          #local SegmentoC      = +AnchoPataMovil/2*x+0.2*AnchoPataMovil*y;
          #local SegmentoQ      = +AnchoPataMovil*x;
          EMBA_SegmentoTriplePunto
            ( SegmentoP, SegmentoC, SegmentoQ, GruesoPataMovil, true, false )
          rotate      -AnguloPataMovil*z
          translate   -AnchoPataMovil*x+AltitudBaseAlta*y
        }
        
      }
    // Fin declare PataMovil
    union               {
      object              {
        PataMovil
        translate  +( LargoBaseAlta/2-GruesoPataFija+GruesoPataMovil/2 )*z
      }
      object              {
        PataMovil
        translate  -( LargoBaseAlta/2-GruesoPataFija+GruesoPataMovil/2 )*z
      }
      intersection      {
        box             {
          ( -LargoBaseAlta/2+GruesoPataFija )*z         ,
          < +2*AnchoPataMovil   , -2*AltitudBaseAlta    ,
            LargoBaseAlta/2-GruesoPataFija              >
        }
        union           {
          box           {
            -AnchoPataFija/4*z                          ,
            < +AnchoPataMovil/2 , -AltitudBaseAlta      ,
              +AnchoPataFija/4                          >
            translate   AltitudBaseAlta/2*y
            rotate      AnguloCruz*x
            translate   -AltitudBaseAlta/2*y
          }
          box           {
            -AnchoPataFija/4*z                          ,
            < +AnchoPataMovil/2 , -AltitudBaseAlta      ,
              +AnchoPataFija/4                          >
            translate   0.1*AnchoPataMovil/2*x
            translate   AltitudBaseAlta/2*y
            rotate      -AnguloCruz*x
            translate   -AltitudBaseAlta/2*y
          }
        }
        rotate      -AnguloPataMovil*z
        translate   -AnchoPataMovil*x+AltitudBaseAlta*y
        texture         {
          TexturaMaderaBarata
        }
      }
      texture             {
        TexturaMadera
      }
      #if ( FraccionGiro = 1.0 )
      #else
        translate       -PuntoGiro
        rotate          ( 1-FraccionGiro )*
                                ( AnguloPataMovil+AnguloGiroGuardar )*z
        translate       +PuntoGiro
      #end
    }
    // Fin PataMovil
    // Inicio Estruturas Metalicas
    #local SujetadorEscuadra            =
      union             {
        box             {
          < -0.4*AnchoBaseAlta, AltitudBaseAlta-0.5*AnchoPataFija       ,
             LargoBaseAlta/2-1.1*GruesoPataFija                         >,
          < +0.4*AnchoBaseAlta, AltitudBaseAlta                         ,
             LargoBaseAlta/2-1.0*GruesoPataFija                         >
        }
        box             {
          < -0.4*AnchoBaseAlta, AltitudBaseAlta-0.1*GruesoPataFija      ,
             LargoBaseAlta/2-1.0*GruesoPataFija-0.5*AnchoPataFija       >,
          < +0.4*AnchoBaseAlta, AltitudBaseAlta                         ,
             LargoBaseAlta/2-1.0*GruesoPataFija                         >
        }
        cylinder        {
          -( LargoBaseAlta/2+0.1*GruesoPataFija )*z             ,
          +( LargoBaseAlta/2+0.1*GruesoPataFija )*z             ,
          0.25*GruesoPataFija
          translate             PuntoGiro
        }
      }
    union               {
      object            {
        SujetadorEscuadra        
      }
      object            {
        SujetadorEscuadra
        scale           <1,1,-1>
      }
      // Link
      #if ( EMBA_Link )
        // link_object fue tomado
        // con pocas modificaciones del archivo
        // fireplug.inc
        // Tomado de la Biblioteca de POVRAY administrada por Micha Riser
        // autor Christophe Bouffartigue de fecha 3 Julio 2000
        // email: christophe.bouffartigue@libertysurf.fr
        // ademas se llama a "link.inc"
        // link.inc
        // Created by Chris Colefax, 20 April 1998
        // puede obtenerse junto con fireplug.inc en la misma fuente
        
        #declare link_object = union {
          torus {.7, .3 clipped_by {box {<-1, -.3, -1>, <0, .3, 1>}} translate -x * .6}
          torus {.7, .3 clipped_by {box {<-1, -.3, -1>, <0, .3, 1>}} translate -x * .6 scale <-1, 1, 1>}
          cylinder {-x*.6, x*.6, .3 translate z * .7}
          cylinder {-x*.6, x*.6, .3 translate -z * .7}
          scale 5*L
        }

        #local   link_looseness  =
          18*FraccionGiro*FraccionGiro-37*FraccionGiro+20;
            // Por prueba y error   0->20  0.5->6  1->20
        #local   link_count      = 20;
        #local   link_twist      = .475;
        #local   scale_links     = false;
        #local   link_point1    = -2/5*AltitudBaseAlta*y
                -1.0*AnchoPataMovil/2*x
                +( LargoBaseAlta/2-GruesoPataFija+GruesoPataMovil+3.5*L )*z;
        #local   link_point1    =
                vaxis_rotate( link_point1, z, -AnguloPataMovil );
        #local   link_point1    =
                vaxis_rotate( link_point1, z,
                ( 1-FraccionGiro )*( AnguloPataMovil+AnguloGiroGuardar ) );
        #local   link_point1    = link_point1+AltitudBaseAlta*y;
        #local   link_point2    = -2/5*AltitudBaseAlta*y
                +1.0*AnchoPataFija/2*x+3.5*L*z
                +LargoBaseAlta/2*z;
        #local   link_point2    =
                vaxis_rotate( link_point2, z, AnguloGiroGuardar );
        #local   link_point2    = link_point2+AltitudBaseAlta*y;
        #local   camera_sky     = y+.001*z;
        #local   camera_sky     =
          vaxis_rotate( camera_sky, z, ( 1-FraccionGiro )*AnguloGiroGuardar );
        #local   MyLink         =
          object          {
            #include "link.inc"
          }
        object          {
          MyLink
        }
        object          {
          MyLink
          scale         <1,1,-1>
        }
      #end
      // Fin Link
      texture           {
        TexturaMetalica
      }
    }
    // Fin Estructuras Metalicas
    texture             {
      TexturaMadera
    }
    #if ( FraccionGiro = 1.0 )
    #else
      translate       -GiroGuardar
      rotate          -( 1-FraccionGiro )*AnguloGiroGuardar*z
      translate       +GiroGuardar
      #local C          = 0;
      #while ( C < TotalEscalones )
        #declare EMBA_Escalones[ C ]    = EMBA_Escalones[ C ]-GiroGuardar;
        #declare EMBA_Escalones[ C ]    =
                vaxis_rotate( EMBA_Escalones[ C ], z,
                        -( 1-FraccionGiro )*AnguloGiroGuardar );
        #declare EMBA_Escalones[ C ]    = EMBA_Escalones[ C ]+GiroGuardar;
        #local C        = C+1;
      #end
    #end
  }
#end

#macro EMBA_Escalera()
  object                {
    EMBA_EscaleraMaderaBajaAltura
        ( 1.0, 3, 1.0, EMBA_DefaultTexturaMadera,
                EMBA_DefaultTexturaMaderaBarata,
                EMBA_DefaultTexturaMetalica )
  }
#end

