// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 6 julio 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LARN LapiceroAzulRojoNegro
// El archivo dibuja un lapicero sencillo.
// La forma mas simple es utilizar la siguiente macro.
// #macro LARN_Lapicero( ColorLapicero, BanderaEscritura )
//      ColorLapicero           : Vector de colorRGB, para la tapa
//              Se recomienda utilizar los colores predefinidos
//              LARN_Rojo, LARN_Azul y LARN_Negro
//      BanderaEscritura        : Si true dibuja el lapicero
//              con la tapa en posicion de escritura.
//              Si false esta cerrado ( Ver modificadores ).
// Las caracteristicas del lapicero son las siguientes.
// Cuando el lapicero esta cerrado, descansa en el eje y+.
// La base inferior en el origen centrado ( la estructura sin tapa ).
// LargoLapicero                : 105*L
// LargoLapicero con Tapa       : 114*L
// DiametroLapicero             : 6*L
// Grueso con Tapa              : 8*L (exceso en x+)
//
// Un poco mas flexible es la siguiente macro
// #macro LARN_LapiceroAzulRojoNegro
//       ( TexturaTapa, TexturaPrincipal, TexturaPlastica2,
//         TexturaTinta, TexturaPunta, TexturaPuntaFinal, BanderaEscritura )
//      TexturaTapa             : define la textura de la tapa.
//              La macro anterior utiliza texture { pigment { LARN_Rojo } },
//              o el color que se indique.
//      TexturaPrincipal        : se aplica en el tronco plastico.
//      TexturaPlastica2        : se aplica al tubito contenedor de tinta.
//      TexturaTinta            : se aplica a la tinta del lapicero.
//      TexturaPunta            : se aplica a la punta metalica
//      TexturaPuntaFinal       : se aplica a la punta fina, en el extremo.
//      BanderaEscritura        : si true el lapicero se encuentra
//              con la tapa en posicion de escritura, si false
//              el lapicero se encuentra cerrado.
//
// La tapa puede generarse independiente con la siguiente
// macro.  Aparece orientada hacia y+.  Su soporte principal
// en el origen, aunque con la agarradera curva prolongada hacia y-.
// Dicha agarradera esta en x+.
// Puede combinarse con el modificador LARN_TapaVisible en off.
// para animacion de la Tapa.
// #macro   LARN_TapaLapicero
//              ( DiametroLapicero, LargoLapicero, TexturaTapa )
//      DiametroLapicero        : Diametro principal del lapicero.
//              Default es LARN_DiametroLapicero
//      LargoLapicero           : Largo del tronco principal
//              del lapicero.  Utilizado como referencia
//              en el modelado de la tapa.
//              Default es LARN_LargoLapicero.
//      TexturaTapa             : Textura del objeto.
//              Default es texture { pigment { color LARN_Rojo } },
//              o el color que se aplique
//
// Las siguientes variables no deberian modificarse
// LARN_PosTapa
//      Vector 3D generado con el llamado a la macro.
//      Indica la colocacion de la tapa.
//      Se genera inclusive cuando no se dibuja la tapa;
//      Lo cual es util en animacion.
// LARN_DiametroLapicero
//      Define el diametro del tronco principal del lapicero.
// LARN_LargoLapicero
//      Define el largo del lapicero, sin la pata inferior.
// LARN_Rojo
//      Define el vector de color de tapa a aplicar en el lapicero Rojo.
// LARN_Azul
//      Define el vector de color de tapa a aplicar en el lapicero Azul.
// LARN_Negro
//      Define el vector de color de tapa a aplicar en el lapicero Negro.
// LARN_TexturaClaraPrincipal
//      Define la textura principal translucida del tronco.
// LARN_TexturaSegundaria
//      Define la textura plastica semitransparente del tubito de tinta.
// LARN_TexturaTinta
//      Define la textura de la tinta.
// LARN_TexturaPunta
//      Define la textura de la punta metalica
// LARN_TexturaPuntaFinal
//      Define la textura del extremo de la punta metalica,
//      algo mas brillante que la anterior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LARN_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare LARN_TapaVisible    = on;
//      En estado off no dibuja la tapa.  Util en animacion.
// #declare LARN_DefaultTexturaClaraPrincipal   = texture ...
//      Define una textura principal del tronco translucido.
// #declare LARN_DefaultTexturaClaraSegundaria  = texture ...
//      Textura default a aplicar en la barrita semitransparente con tinta.
// #declare LARN_DefaultTexturaTinta            = texture ...
//      Textura default para la tinta.
// #declare LARN_DefaultTexturaPunta            = texture ...
//      Define una textura default para la punta del lapicero.
// #declare LARN_DefaultTexturaPuntaFinal       = texture ...
//      Otra textura default para el extremo final de la punta.
//
// Para colocarlo simplemente
// #include "LARN.inc"
// object { LARN_Lapicero( LARN_Negro, false ) }
//
// Otro ejemplo con modificador
// #include "LARN.inc"
// #declare "LARN_DefaultTexturaPuntaFinal       = texture       {
//   average
//   texture_map        {
//     [ 0.8 Rust                               ]
//     [ 0.2 LARN_TexturaPuntaFinal             ]
//   }
// }
// #declare LARN_TapaVisible    = off;
// object       { LARN_Lapicero( LARN_Rojo, true ) }
// object       {
//   LARN_TapaLapicero( LARN_DiametroLapicero, LARN_LargoLapicero,
//                texture { pigment { LARN_Rojo } } )
//   scale      <1,-1,1>
//   translate  LARN_PosTapa-0.1*clock*y
// }
//

#include "colors.inc"
global_settings         { max_trace_level 10 }

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
#include "LARN.inc"

#local FactorAcercamiento       = 8;

object          {
  LARN_Lapicero( LARN_Rojo, false )
  translate     -LARN_LargoLapicero/2*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}



