// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 junio 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Las macro LRAV_LagartijaReptilAnimalVivo()
// crea el dibujo de una Lagartija en estilo 3D
// con el centro del tronco en el origen y la
// cabeza orientada hacia z+
// LargoTotal           : 1350*L (+400*L -950*L)*z
// ProfundidadTotal     : 180*L  (+ 90*L - 90*L)*y
// Ancho Sin Patas      : 240*L
// Ancho Con Patas      : 550*L
//
// La lagartija puede curvarse mediante una macro
// algo mas flexibe
// #macro LRAV_Lagartija( MyArreglo )
//
// #declare MyArreglo   = array [ GirosSolicitados ][ 4/5 ]
//      GirosSolicitados        : indica el total de giros a solicitar
//         El numero es libre, con un maximo de 55,
//         El giro tiene el siguiente formato
//        { IdentificadorGiro, RotarX, RotarY, RotarZ }
//         o bien este otro
//        { IdentificadorGiro, RotarX, RotarY, RotarZ, on/off }
//         la bandera off desactiva el giro, lo que podria ser util
//         al disenar.
//         Utiliza rotacion acumulada.
//         Cada tipo de giro solo debe encontarse una unica vez
//         en cualquier orden.
// IdentificadorGiro    : Numero o etiqueta clave que identifica el giro
// RotarX               : Indica la rotacion en grados respecto eje X*,
//        este es el eje X, luego de aplicar rotacion en
//        en otros puntos de control
//        LRAV_LagartijaReptilAnimalVivo() dibuja en la posicion base.
// RotarY               : Indica rotacion acumulada respecto eje Y*,
//        este es el eje Y luego de aplicar RotarX
// RotarZ               : Indica rotacion acumulada respecto eje Z*,
//        este es el eje Z luego de aplicar RotarX y RotarY
// on/off               : variable optativa,
//        si off no se gira, util en diseo y animacion.
//
// La siguiente es la lista de IdentificadorGiro admisibles:
//   Ejes en el tronco, en total 15 (atras es z- hacia cola y delante es z+)
// LRAV_EjeCentral        = Ubicado al centro del tronco
// LRAV_EjeCentralI01     = Ubicado atras de LRAV_EjeCentral
// LRAV_EjeCentralI02     = Ubicado atras de LRAV_EjeCentralI01
// LRAV_EjeCentralI03     = Ubicado atras de LRAV_EjeCentralI02
// LRAV_EjeCentralI04     = Ubicado atras de LRAV_EjeCentralI03
// LRAV_EjeCentralI05     = Ubicado atras de LRAV_EjeCentralI04
// LRAV_EjeCentralI06     = Ubicado atras de LRAV_EjeCentralI05
// LRAV_EjeCentralI07     = Ubicado atras de LRAV_EjeCentralI06
// LRAV_EjeCentralD01     = Ubicado delante de LRAV_EjeCentral
// LRAV_EjeCentralD02     = Ubicado delante de LRAV_EjeCentralD01
// LRAV_EjeCentralD03     = Ubicado delante de LRAV_EjeCentralD02
// LRAV_EjeCentralD04     = Ubicado delante de LRAV_EjeCentralD03
// LRAV_EjeCentralD05     = Ubicado delante de LRAV_EjeCentralD04
// LRAV_EjeCentralD06     = Ubicado delante de LRAV_EjeCentralD05
// LRAV_EjeCentralD07     = Ubicado delante de LRAV_EjeCentralD06
//   Ejes en la cola desde el tronco hacia atras ( en total 10 )
// LRAV_EjeCola01         = Ubicado atras del tronco
// LRAV_EjeCola02         = Ubicado atras de LRAV_EjeCola01
// LRAV_EjeCola03         = Ubicado atras de LRAV_EjeCola02
// LRAV_EjeCola04         = Ubicado atras de LRAV_EjeCola03
// LRAV_EjeCola05         = Ubicado atras de LRAV_EjeCola04
// LRAV_EjeCola06         = Ubicado atras de LRAV_EjeCola05
// LRAV_EjeCola07         = Ubicado atras de LRAV_EjeCola06
// LRAV_EjeCola08         = Ubicado atras de LRAV_EjeCola07
// LRAV_EjeCola09         = Ubicado atras de LRAV_EjeCola08
// LRAV_EjeCola10         = Ubicado atras de LRAV_EjeCola09
//   Ejes en la cabeza de detras hacia adelante
// LRAV_EjeCabeza01       = Ubicado en el cuello
// LRAV_EjeCabeza02       = Ubicado delante de LRAV_EjeCabeza01
//   Ejes en pata delantera izquierda (z+,x+)
// LRAV_EjeAntePataDI     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataDI         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorDI = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorDI = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorDI   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorDI   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioDI    = Ubicado en punto de union del dedo medio
//   Ejes en pata delantera derecha (z+,x-)
// LRAV_EjeAntePataDD     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataDD         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorDD = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorDD = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorDD   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorDD   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioDD    = Ubicado en punto de union del dedo medio
//   Ejes en pata trasera izquierda (z-,x+)
// LRAV_EjeAntePataTI     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataTI         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorTI = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorTI = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorTI   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorTI   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioTI    = Ubicado en punto de union del dedo medio
//   Ejes en pata trasera derecha (z-,x-)
// LRAV_EjeAntePataTD     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataTD         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorTD = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorTD = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorTD   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorTD   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioTD    = Ubicado en punto de union del dedo medio
//
// PREDEFINIDOS
// Las siguientes variables no deberian modificarse
// LRAV_TexturaDedo
//      Define la textura a aplicar en los dedos.
// LRAV_TexturaOjo
//      Define la textura del ojo.
// LRAV_TexturaCabeza
//      Define la textura a aplicar en la cabeza.
// LRAV_TexturaTronco
//      Define la textura a aplicar en el tronco.
// LRAV_TexturaCola
//      Define la textura a aplicar en la cola.
// LRAV_TexturaPata
//      Define la textura a aplicar en la pata.
// LRAV_TexturaAntePata
//      Define la textura a aplicar en la antepierna.
//
// MODIFICADORES
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRAV_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare LRAV_Textura2       = off;
//      Valor on aplica textura alternativa creada
//      por compatibilidad con POVRay 3.1. pero es una alternativa util.
//      Deberia declararse antes del #include para que funcione.
// #declare LRAV_BanderaBoca    = on;
//      Valor off elimina la boca.  Util si se quiere sustituir por un
//      mejor diseno.
// #declare LRAV_ColorBoca      = DarkGreen;
//      Permite cambiar el color de la boca.
// #declare LRAV_DefaultTexturaDedo                     = texture { ... }
//      Define la textura default a aplicar en los dedos.
// #declare LRAV_DefaultTexturaOjo                      = texture { ... }
//      Define la textura default del ojo.
// #declare LRAV_DefaultTexturaCabeza                   = texture { ... }
//      Define la textura default a aplicar en la cabeza.
// #declare LRAV_DefaultTexturaTronco                   = texture { ... }
//      Define la textura default a aplicar en el tronco.
// #declare LRAV_DefaultTexturaCola                     = texture { ... }
//      Define la textura default a aplicar en la cola.
// #declare LRAV_DefaultTexturaPata                     = texture { ... }
//      Define la textura default a aplicar en la pata.
// #declare LRAV_DefaultTexturaAntePata                 = texture { ... }
//      Define la textura default a aplicar en la antepierna.
//
// Para colocarlo simplemente
// #include "LRAV.inc"
// object { LRAV_LagartijaReptilAnimalVivo() }
//
// Otro ejemplo
// #include "LRAV.inc"
// #declare MFVS_DefaultTexturaDedo             = texture       {
//   average
//   texture_map        {
//     [ 0.5 Custom...                          ]
//     [ 0.5 LRAV_TexturaDedo                   ]
//   }
// }
// #declare MyArreglo   = array [ 2 ][ 4 ]
//      { { LRAV_EjeCentral, 0, 10, 0 },
//        { LRAV_EjeCola01 , 0,-10, 0 } }
// object       { LRAV_Lagartija( MyArreglo ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         ForestGreen
}                 
#declare LRAV_Textura2  = on;
#include "LRAV.inc"
     
#local   FactorAcercamiento             = 10;
     
#declare MyArreglo      = array [ 9 ][ 5 ]
  {
    { LRAV_EjeCola02    , 0, 30, 0, on
    },
    { LRAV_EjeCola04    , 0, 10, 0, on
    },
    { LRAV_EjeCola06    , 0,-20, 0, on
    },
    { LRAV_EjeCentralI02, 0,-20, 0, on
    },
    { LRAV_EjeCentralD02, 0,-20, 0, on
    },
    { LRAV_EjeCabeza02  , 0, 20, 0, on
    }, 
    { LRAV_EjeAntePataTD, 0, 45, 0, on
    },
    { LRAV_EjeAntePataTI, 0,-35, 0, on
    },
    { LRAV_EjePataDI    , 0, 30, 0, on
    }    
  }
  
object          {
  LRAV_Lagartija( MyArreglo )
  rotate        90*y
  rotate        -45*x
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}