// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 mayo 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Las macros MFVS_Molinete1(), MFVS_Molinete2(), y MFVS_Molinete3()
// crean figuras muy similares, con variaciones en la textura
// La extructura que gira sobresale en direccion z-,
// la base del giro principal descansa en el origen.
// Radio Giro           : 57*L
// Grueso Giro          : 30*L (desde 0 hasta -30*L*z)
// Profundidad Palito   : 18*L*z
// Largo Palito         : 300*L (27*L*y hasta -273*L*y)
// Diametro Palito      : 5*L
//
// El objeto puede generarse via una macro principal de texturas
// #macro MFVS_MolineteFeriaVientoSoplo( Semilla, AnguloGiro,
//                Colorido1, Colorido2, Colorido3, Metalica )
//      Semilla                 : para aleatoriedad, misma semilla,
//                misma estructura de molinete.
//      AnguloGiro              : angulo de giro del molinete
//                cuando es cero, una hoja apunta hacia y+.
//      Colorido1               : una textura de las hojas del molinete.
//      Colorido2               : otra textura de las hojas del molinete.
//      Colorido3               : textura del palito.
//      Metalica                : textura del alambrito soporte.
//
// Las siguientes variables no deberian modificarse
// MFVS_TexturaColorido1A
//      Define una textura de las hojas del molinete1.
// MFVS_TexturaColorido1B
//      Otra textura de las hojas del molinete1.
// MFVS_TexturaColorido1C
//      Textura del palito del molinete1.
// MFVS_TexturaColorido2A
//      Define una textura de las hojas del molinete2.
// MFVS_TexturaColorido2B
//      Otra textura de las hojas del molinete2.
// MFVS_TexturaColorido2C
//      Textura del palito del molinete2.
// MFVS_TexturaColorido3A
//      Define una textura de las hojas del molinete3.
// MFVS_TexturaColorido3B
//      Otra textura de las hojas del molinete3.
// MFVS_TexturaColorido3C
//      Textura del palito del molinete3.
// RBSA_TexturaMetalica
//      Define la textura del alambrito soporte.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare RBSA_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare MFVS_DefaultTexturaColorido1A       = texture ...
//      Define una textura default de las hojas del molinete1.
// #declare MFVS_DefaultTexturaColorido1B       = texture ...
//      Otra textura default de las hojas del molinete1.
// #declare MFVS_DefaultTexturaColorido1C       = texture ...
//      Textura default del palito del molinete1.
// #declare MFVS_DefaultTexturaColorido2A       = texture ...
//      Define una textura default de las hojas del molinete2.
// #declare MFVS_DefaultTexturaColorido2B       = texture ...
//      Otra textura default de las hojas del molinete2.
// #declare MFVS_DefaultTexturaColorido2C       = texture ...
//      Textura del palito default del molinete2.
// #declare MFVS_DefaultTexturaColorido3A       = texture ...
//      Define una textura default de las hojas del molinete3.
// #declare MFVS_DefaultTexturaColorido3B       = texture ...
//      Otra textura default de las hojas del molinete3.
// #declare MFVS_DefaultTexturaColorido3C       = texture ...
//      Textura default del palito del molinete3.
// #declare RBSA_DefaultTexturaMetalica         = texture ...
//      Define la textura default del alambrito soporte.
//
// Para colocarlo simplemente
// #include "MFVS.inc"
// object { MFVS_Molinete1() }
//
// Otro ejemplo con modificador
// #include "MFVS.inc"
// #declare MFVS_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.5 MFVS_Rust                          ]
//     [ 0.5 MFVS_TexturaMetalica               ]
//   }
// }
// object       { MFVS_Molinete1() }
//

#include "colors.inc"

#local   EjeMejorado            = false;
#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;     
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White*0.8
}
light_source    {
         <-500  , 500   , -3000 >*L
         White*0.8
}
background      {
         Gray50
}    

#include "MFVS.inc"

#local   FactorAcercamiento             = 3.5;

union           {
  object          {
    MFVS_Molinete1()
    translate   -0.15*x
  }
  object          {
    MFVS_Molinete2()
  }
  object          {
    MFVS_Molinete3()
    translate   +0.15*x
  }
  translate     0.1*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}



