// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 enero 2012
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// PCCM ParrillaCocinaCircularMetal
// El archivo dibuja una parrilla negra simple.
// Puede utilizar la siguiente macro sin parametros
// #macro PCCM_Parrilla()
//
// Genera una parrilla con las siguientes caracteristicas
// Minimo : < -76,   0, -76 >*L
// Maximo : < 174,  23,  76 >*L
// Las patas sobre el plano XZ, y la agarradera hacia X+
//
// Un poco mas flexible es la siguiente macro
//  #macro PCCM_ParrillaCocinaCircularMetal(
//                DiametroParrilla, DiametroAlambre, AlturaParrilla,
//                TexturaBorde, TexturaParrillaRed,
//                TexturaAgarradera, TexturaPatitas )
//      DiametroParrilla        : Diametro del circulo para comida.
//              Default 146*L.
//      DiametroAlambre         : Grueso del alambre de soporte.
//              Default 2.15*L.
//      AlturaParrilla          : Referencia para la altura de parrilla.
//              En realidad el dibujo es algo mayor.  Default 20*L.
//      TexturaBorde            : Se aplica al borde circular, y la
//              linea interna que prolonga la agarradera.
//      TexturaParrillaRed      : Textura a aplicar a la rejilla
//              metalica.
//      TexturaAgarradera       : Textura a aplicar a la agarradera.
//      TexturaPatitas          : Textura a aplicar a las patitas.
//
// Las siguientes variables no deberian modificarse
// PCCM_TexturaBorde            :
//      Se aplica al borde circular, y la
//      linea interna que prolonga la agarradera.
// PCCM_TexturaParrillaRed      :
//      Textura a aplicar a la rejilla metalica.
// PCCM_TexturaAgarradera       :
//      Textura a aplicar a la agarradera.
// PCCM_TexturaPatitas          :
//      Textura a aplicar a las patitas.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare PCCM_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare PCCM_DefaultTexturaBorde            = texture...
//      Textura default que se aplica al borde circular, y la
//      linea interna que prolonga la agarradera.
// #declare PCCM_DefaultTexturaParrillaRed      = texture...
//      Textura default a aplicar a la rejilla metalica.
// #declare PCCM_DefaultTexturaAgarradera       = texture...
//      Textura default a aplicar a la agarradera.
// #declare PCCM_DefaultTexturaPatitas          = texture...
//      Textura default a aplicar a las patitas.
//
// Para colocarlo simplemente
// #include "PCCM.inc"
// object { PCCM_Parrilla() }
//
// Otro ejemplo con modificador
// #include "PCCM.inc"
// #declare "PCCM_DefaultTexturaBorde       = texture       {
//   average
//   texture_map        {
//     [ 0.8 Rust                               ]
//     [ 0.2 PCCM_TexturaBorde                  ]
//   }
// }
// object       {
//   PCCM_Parrilla()
// }
//
// Un ejemplo con la macro larga
// #include "PCCM.inc"
// object                {
//    PCCM_ParrillaCocinaCircularMetal( 146*L, 2.15*L, 20*L,
//        PinkAlabaster, PinkAlabaster,
//        PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#declare EjeMejorado            = false;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}

#include "PCCM.inc"

#local FactorAcercamiento       = 7;

object          {
  PCCM_Parrilla()
  rotate        90*x
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
         -40*L*x
}
