// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// PVBN PortaVasosBebidaNacional
// El archivo dibuja un sencillo portavasos
// No es compatible con PovRay3.0   
// #macro PVBN_PortaVasos( DibujarBandeja )
//      DibujarBandeja          : on  dibuja la bandeja
//                                off no la dibuja
// Las dimensiones default serian
//      AlturaTotal             = 210*L
//      AlturaSoporteVaso       = 150*L 
//      FrenteBase              = 158*L 
//      FrenteBandeja           = 200*L
//      AnchoBase               = 120*L
//      AnchoBandeja            < 120*L  
//
// Se encuentra centrado en el origen sobre el plano XZ
// El frente (lado largo) en linea con el eje X
// Soporte hacia arriba Y+.
//    
// La bandeja se puede dibujar en forma independiente
// con la siguiente macro
// #macro PVBN_Bandeja( Largo, Ancho, Profundidad, Grueso )
//      Largo                   = Frente de Portavasos,
//                                la bandeja es mayor default 157*L
//      Ancho                   = Ancho de referencia
//                                en realidad es mayor
//                                default 73.6*L
//      Profundidad             = Referencia para la altura
//                                de la bandeja, en realidad
//                                es menor 14.6*L
//      Grueso                  = Grueso de bandeja 0.73*L (no uniforme)
// Se dibuja sin textura, puede ubicarse en posicion default
// object       {
//   PVBN_Bandeja( 157*L, 73.6*L, 14.6*L, 0.73*L )
//   translate  PVBN_PosBandeja
//   texture    { PVBN_DefaultTexturaBandeja }
// }                             
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare PVBN_PosBandeja             = Posicion de referencia
//      inicial de la bandeja.  Se calculo al llamar a la
//      macro PVBN_PortaVasos, inclusive en el caso off.
//      Sirve para animar movimiento en la bandeja.
// #declare PVBN_PuntoPalito            = array[6]
//      Contiene una lista de puntos que puede servir
//      para colocar los vasos en el Portavasos,
//      Se calculan al llamar a la macro PVBN_PortaVasos
//      Estiman el punto central superior 
//      de cada uno de los seis soportes
// #declare PVBN_TexturaBandeja         = texture { ... }
//      Textura a aplicar a la bandeja
// #declare PVBN_TexturaMetal           = texture { ... }
//      Textura a aplicar a las zonas metalizadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario 
// #declare PVBN_DefaultTexturaBandeja  = texture { ... }
//      Textura default a aplicar a la bandeja
// #declare PVBN_DefaultTexturaMetal    = texture { ... }
//      Textura default a aplicar a las zonas metalizadas
//
// Para colocarlo simplemente
// #include "PVBN.inc"
// object { PVBN_PortaVasos( on ) }
//
// Otro ejemplo con modificador
// #include "PVBN.inc"
// #declare PVBN_DefaultTexturaBandeja          = texture       {
//   PinkAlabaster
// }
// #declare PVBN_DefaultTexturaMetal            = texture       {
//   average
//   texture_map        {
//     [ 0.5 PVBN_TexturaMetal          ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// object               {
//   PVBN_PortaVasos( off )
// }
// cylinder             {
//   PVBN_PuntoPalito[2], PVBN_PuntoPalito[2]+0.01*y
//   texture            {
//     PVBN_TexturaBandeja
//   }
// }
//
 
#include "colors.inc"
#include "stones.inc"   
#include "glass.inc"
#include "transforms.inc"

#declare PVBN_L                 = 0.001;    
    
#declare PVBN_TexturaBandeja                    =
  texture       {   
    T_Stone26
  }    
    
#ifndef ( PVBN_DefaultTexturaBandeja )
  #declare PVBN_DefaultTexturaBandeja           =
        texture         {
          PVBN_TexturaBandeja
        }
#end

#declare PVBN_TexturaMetal                      =
  texture               {
        pigment         {
          Silver
        }
  }      

#ifndef ( PVBN_DefaultTexturaMetal ) 
  #declare PVBN_DefaultTexturaMetal             =
        texture       {
          PVBN_TexturaMetal
        }
#end

#macro PVBN_Bandeja( Largo, Ancho, Profundidad, Grueso )
  union                         {
    #local Sobre                = < Largo, Profundidad, Ancho >/2;
    #local FiguraSobre          =
      union                     {
        box                     {
          -Sobre, Sobre
        }
        sphere                  {
          Sobre*<1,0,1>,
          Profundidad/2
        }
        cylinder                {
          Sobre*<1,0,1>,
          Sobre*<1,0,0>,
          Profundidad/2
        }
        cylinder                {
          Sobre*<1,0,1>,
          Sobre*<0,0,1>,
          Profundidad/2
        }
      }
    #local FiguraSobre2         =
      union                     {
        #local C                = 0;
        #while ( C < 2 )
          object { 
            FiguraSobre 
            rotate      C*180*y
          }   
          object        {
            FiguraSobre
            scale       <1,1,-1>
            rotate      C*180*y
          }
          #local C              = C+1;
        #end
      }
    #local BordeSobre           =
      union                     {
        difference              {
          torus                 {
            Profundidad, Profundidad/2
          }
          plane { z, 0 }
          plane { x, 0 }
          translate             Sobre*<1,0,1>
        }
        cylinder                {
          Sobre*<1,0,1>+Profundidad*x,
          Sobre*<1,0,0>+Profundidad*x,
          Profundidad/2
        }
        cylinder                {
          Sobre*<1,0,1>+Profundidad*z,
          Sobre*<0,0,1>+Profundidad*z,
          Profundidad/2
        }
      }
    #local BordeSobre2          =  
      union                     {
        #local C                = 0;
        #while ( C < 2 )
          object { 
            BordeSobre 
            rotate      C*180*y
          }   
          object        {
            BordeSobre
            scale       <1,1,-1>
            rotate      C*180*y
          }
          #local C              = C+1;
        #end
      }
    difference                  {
      object            {
        FiguraSobre2
      }
      object            {
        FiguraSobre2
        scale           <0.95,0.9,0.95>
      }
      plane             {
        -y, 0
      }
    }
    difference          {
      object            {
        BordeSobre2
      }
      plane             {
        y, 0
      }
    }
    texture             {  
      PVBN_DefaultTexturaBandeja
    }
  }
#end

#macro PVBN_PortaVasos( DibujarBandeja )
  #local L                              = PVBN_L;
  #local DiametroEsferaBase             = 5*L;
  #local CorrimientoBase                = 36.5*L;
  #local CorrimientoZBase               = 14*L;
  #local LargoPortaVasos                = 157*L;     
  #local AltoAlambrito                  = 112*L;
  #local AnchoPortaVasos                = 92*L;
  #local DiametroAlambrito              = 2*L;
  #local SeparacionBaseA                = 14*L;
  #local RadioEsquinero                 = 11*L;
  #local SoportePrincipal               = 29*L;
  #local DiametroSoportePrincipal       = 3*L;
  #local AltoCorazonCentral             = 161*L;  
  #local TotalAritos                    = 60;  
  #local RadioInferiorVaso              = 21.5*L;
  #local RadioSuperiorVaso              = 27*L;
  #local AlturaVaso                     = 101*L;
  #local BaseVaso                       = 5*L;
  #local DiametroArito                  = DiametroAlambrito/3;
  #local BaseEstructuraA                = 
    union               {
      cylinder          {
        +LargoPortaVasos/2*x-( AnchoPortaVasos/2-RadioEsquinero )*z,
        +LargoPortaVasos/2*x,
        DiametroAlambrito/2
      }
      cylinder          {
        -AnchoPortaVasos/2*z,
        -AnchoPortaVasos/2*z+( LargoPortaVasos/2-RadioEsquinero )*x,
        DiametroAlambrito/2
      }
      difference        {
        torus           {
          RadioEsquinero        ,
          DiametroAlambrito/2
        }
        plane           {
          x             , 0
        }
        plane           {
          -z            , 0
        }
        translate       +( LargoPortaVasos/2-RadioEsquinero )*x
                        -( AnchoPortaVasos/2-RadioEsquinero )*z
      }  
      cylinder          {
        +DiametroAlambrito*y,
        +DiametroAlambrito*y+LargoPortaVasos/2*x,
        DiametroAlambrito/2
      }
    }
  #local BaseEstructuraB                =
    union               {
      object            { BaseEstructuraA } 
      object            {
        BaseEstructuraA
        translate       SeparacionBaseA*y
      }
      cylinder          {
        +( LargoPortaVasos/2-SoportePrincipal )*x,
        +( LargoPortaVasos/2-SoportePrincipal )*x
        -AnchoPortaVasos/2*z,
        DiametroSoportePrincipal/2
        translate       
                -( DiametroAlambrito+DiametroSoportePrincipal )/2*y
      }
      sphere            {
        -( AnchoPortaVasos/2+CorrimientoZBase )*z
        -( CorrimientoBase-DiametroEsferaBase/2 )*y
        +( LargoPortaVasos/2-SoportePrincipal )*x,
        DiametroEsferaBase/2
      } 
      #local PuntoEsfera        =
        -( CorrimientoZBase )*z
        -( CorrimientoBase-
                ( DiametroEsferaBase+DiametroAlambrito
                +DiametroSoportePrincipal )/2 )*y
        +( LargoPortaVasos/2-SoportePrincipal )*x;
      sphere_sweep      {
        cubic_spline,
        6,
        <1,0,-0.5>*PuntoEsfera, DiametroSoportePrincipal/2,
        <1,0,0>*PuntoEsfera, DiametroSoportePrincipal/2,
        <1,0.25,1>*PuntoEsfera,
        DiametroSoportePrincipal/2,
        <1,0.75,0>*PuntoEsfera,
        DiametroSoportePrincipal/2,
        <1,1.00,1>*PuntoEsfera,
        DiametroSoportePrincipal/2,
        <1,1.10,1.1>*PuntoEsfera,
        DiametroSoportePrincipal/2
        translate       -AnchoPortaVasos/2*z
               -( DiametroSoportePrincipal+DiametroAlambrito )/2*y
      }  
    }     
    #local PalitoCorazon        =
      union             {
        cylinder        {
          -( AnchoPortaVasos/2-DiametroAlambrito )*z,
          -( AnchoPortaVasos/2-DiametroAlambrito )*z
          +AltoAlambrito*y,
          DiametroAlambrito/2
        }
        #local PuntoCorazon     =
                -( AnchoPortaVasos/2-DiametroAlambrito )*z
                +AltoAlambrito*y+0.125*LargoPortaVasos/2*x;
        sphere_sweep    {
          cubic_spline
          7,
          <-1,1,1>*PuntoCorazon, 
          DiametroAlambrito/2,
          <0,1,1>*PuntoCorazon, 
          DiametroAlambrito/2,
          <1,1,1.05>*PuntoCorazon, 
          DiametroAlambrito/2,
          <0,1,0.6>*PuntoCorazon, 
          DiametroAlambrito/2,
          <-1,1,1.05>*PuntoCorazon, 
          DiametroAlambrito/2,
          <0,1,1>*PuntoCorazon, 
          DiametroAlambrito/2,
          <1,1,1>*PuntoCorazon, 
          DiametroAlambrito/2
        }
      }
    #local PuntoCorazonCentral          =
      < LargoPortaVasos/6, AltoCorazonCentral,
        ( DiametroAlambrito+DiametroSoportePrincipal )/2 >; 
    #local SplineCorazonCentral         =
      spline            {
        cubic_spline
        -1      , PuntoCorazonCentral*< 0.1, 0.00, 1.0>,
        -0.5    , PuntoCorazonCentral*< 0.1, 0.40, 1.0>,
        +0      , PuntoCorazonCentral*< 0.1, 0.80, 1.0>,
        +0.25   , PuntoCorazonCentral*< 1.0, 1.00, 1.0>,
        +0.40   , PuntoCorazonCentral*< 0.7, 1.05, 1.0>,
        +0.50   , PuntoCorazonCentral*< 0.0, 1.00, 1.0>,
        +0.60   , PuntoCorazonCentral*<-0.7, 1.05, 1.0>,
        +0.75   , PuntoCorazonCentral*<-1.0, 1.00, 1.0>,
        +1.0    , PuntoCorazonCentral*<-0.1, 0.80, 1.0>,
        +1.5    , PuntoCorazonCentral*<-0.1, 0.40, 1.0>,
        +2.0    , PuntoCorazonCentral*<-0.1, 0.00, 1.0>
      } 
    #local DecoradoCorazonCentral       =
      union             {
        cylinder        {
          PuntoCorazonCentral*<0.1,0,1>,
          PuntoCorazonCentral*<0.1,0.8,1>,
          DiametroSoportePrincipal/2
        }
        cylinder        {
          PuntoCorazonCentral*<-0.1,0,1>,
          PuntoCorazonCentral*<-0.1,0.8,1>,
          DiametroSoportePrincipal/2
        } 
        sphere_sweep    {
          cubic_spline
          9,
          SplineCorazonCentral(-0.50), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.00), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.25), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.40), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.50), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.60), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 0.75), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 1.00), DiametroSoportePrincipal/2,
          SplineCorazonCentral( 1.50), DiametroSoportePrincipal/2
        }
        #local C                        = 0;   
        #while ( C < TotalAritos )
          torus         {
            DiametroSoportePrincipal, DiametroArito/2
            #local VectorPos            =
                        SplineCorazonCentral( C/TotalAritos );
            #local VectorDir            =
                  SplineCorazonCentral( ( C+1 )/TotalAritos )-VectorPos;
            Reorient_Trans( y, VectorDir )
            translate           VectorPos
          }
          #local C                      = C+1;
        #end
      }
  union                 {
    #local C                            = 0;
    #while ( C < 2 )         
      union             {
        object            {
          BaseEstructuraB
        }
        object            {
          BaseEstructuraB
          scale         <1,1,-1>
        }
        rotate          180*C*y
      }
      #local C                          = C+1;
    #end
    #declare PVBN_PuntoPalito           = array[ 6 ]
    #local C                            = 0;
    #while ( C < 3 )
      object            {
        PalitoCorazon
        translate       ( C-1 )*LargoPortaVasos/3*x
      }    
      #declare PVBN_PuntoPalito[ C   ]          = 
                < (C-1)*LargoPortaVasos/3, 
                  AltoAlambrito+DiametroAlambrito+CorrimientoBase, 
                  0.85*AnchoPortaVasos/2 >;
      #declare PVBN_PuntoPalito[ C+3 ]          = 
                                PVBN_PuntoPalito[ C ]*<1,1,-1>;
      object            {
        PalitoCorazon
        scale           <1,1,-1>
        translate       ( C-1 )*LargoPortaVasos/3*x
      }
      #local C                          = C+1;
    #end 
    object              {
      DecoradoCorazonCentral
    }   
    #if ( DibujarBandeja )
      object              {
        PVBN_Bandeja( LargoPortaVasos, 0.8*AnchoPortaVasos,
                0.4*CorrimientoBase, 0.02*CorrimientoBase )
        translate         -0.4*CorrimientoBase*y
      }    
    #end
    translate           +CorrimientoBase*y
    #declare    PVBN_PosBandeja         = +0.6*CorrimientoBase*y;
    texture             {   
      PVBN_DefaultTexturaMetal
    }
  }
#end