// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// PVBN PortaVasosBebidaNacional
// El archivo dibuja un sencillo portavasos
// No es compatible con PovRay3.0   
// #macro PVBN_PortaVasos( DibujarBandeja )
//      DibujarBandeja          : on  dibuja la bandeja
//                                off no la dibuja
// Las dimensiones default serian
//      AlturaTotal             = 210*L
//      AlturaSoporteVaso       = 150*L 
//      FrenteBase              = 158*L 
//      FrenteBandeja           = 200*L
//      AnchoBase               = 120*L
//      AnchoBandeja            < 120*L  
//
// Se encuentra centrado en el origen sobre el plano XZ
// El frente (lado largo) en linea con el eje X
// Soporte hacia arriba Y+.
//    
// La bandeja se puede dibujar en forma independiente
// con la siguiente macro
// #macro PVBN_Bandeja( Largo, Ancho, Profundidad, Grueso )
//      Largo                   = Frente de Portavasos,
//                                la bandeja es mayor default 157*L
//      Ancho                   = Ancho de referencia
//                                en realidad es mayor
//                                default 73.6*L
//      Profundidad             = Referencia para la altura
//                                de la bandeja, en realidad
//                                es menor 14.6*L
//      Grueso                  = Grueso de bandeja 0.73*L (no uniforme)
// Se dibuja sin textura, puede ubicarse en posicion default
// object       {
//   PVBN_Bandeja( 157*L, 73.6*L, 14.6*L, 0.73*L )
//   translate  PVBN_PosBandeja
//   texture    { PVBN_DefaultTexturaBandeja }
// }                             
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare PVBN_PosBandeja             = Posicion de referencia
//      inicial de la bandeja.  Se calculo al llamar a la
//      macro PVBN_PortaVasos, inclusive en el caso off.
//      Sirve para animar movimiento en la bandeja.
// #declare PVBN_PuntoPalito            = array[6]
//      Contiene una lista de puntos que puede servir
//      para colocar los vasos en el Portavasos,
//      Se calculan al llamar a la macro PVBN_PortaVasos
//      Estiman el punto central superior 
//      de cada uno de los seis soportes
// #declare PVBN_TexturaBandeja         = texture { ... }
//      Textura a aplicar a la bandeja
// #declare PVBN_TexturaMetal           = texture { ... }
//      Textura a aplicar a las zonas metalizadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario 
// #declare PVBN_DefaultTexturaBandeja  = texture { ... }
//      Textura default a aplicar a la bandeja
// #declare PVBN_DefaultTexturaMetal    = texture { ... }
//      Textura default a aplicar a las zonas metalizadas
//
// Para colocarlo simplemente
// #include "PVBN.inc"
// object { PVBN_PortaVasos( on ) }
//
// Otro ejemplo con modificador
// #include "PVBN.inc"
// #declare PVBN_DefaultTexturaBandeja          = texture       {
//   PinkAlabaster
// }
// #declare PVBN_DefaultTexturaMetal            = texture       {
//   average
//   texture_map        {
//     [ 0.5 PVBN_TexturaMetal          ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// object               {
//   PVBN_PortaVasos( off )
// }
// cylinder             {
//   PVBN_PuntoPalito[2], PVBN_PuntoPalito[2]+0.01*y
//   texture            {
//     PVBN_TexturaBandeja
//   }
// }
//

global_settings {
  max_trace_level       20
}

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#local FactorAcercamiento       = 6;

#include "PVBN.inc"

object  {
  PVBN_PortaVasos( on )
  translate     -100*L*y
  translate     -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}