// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 mayo 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// La macro RSBA_RuedaBicicletaPequena()
// genera un objeto con
// las siguientes caracteristicas
// Rueda en el plano xz, centrada en el origen
// Radio Principal      : 215*L
// Diametro Neumatico   : 36*L
// Ancho Total Z        : 93*L
// Ancho Envarillado Z  : 54*L
//
// El objeto puede generarse via una macro principal de texturas
// #macro RBSA_RuedaBicicletaSinAccesorios
//    ( RadioTotal, DiametroRueda, AnchoMetalico, TexturaRodante,
//      TexturaRodante, TexturaRuedaInterior, TexturaMetalica, MaterialLuz )
//      RadioTotal                      : Radio total de rueda
//      DiametroRueda                   : Diametro del caucho
//      AnchoMetalico                   : Ancho en Z del envarillado
//              sin los tornillos y el soporte cilindrico
//      TexturaRodante                  : Textura del caucho oscuro
//              en contacto con la carretera
//      TexturaRuedaInterior            : Textura del caucho hacia
//              el interior de la llanta
//      TexturaMetalica                 : Textura de las varillas
//      MaterialLuz                     : Material de la luz de seguridad
//
// Las siguientes variables no deberian modificarse
// RBSA_TexturaRodante
//      Define la textura del caucho en contacto con la carretera
// RBSA_TexturaRuedaInterior
//      Define la textura del caucho hacia el interior de la llanta
// RBSA_TexturaMetalica
//      Define la textura del envarillado
// RBSA_MaterialLuz
//      Define el material la luz de seguridad
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare RBSA_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare RBSA_DefaultTexturaRodante                  = texture ...
//      Define la textura utilizada en el caucho en contacto
//      con la carretera
// #declare RBSA_DefaultTexturaRuedaInterior            = texture ...
//      Define la textura utilizada en el caucho hacia el
//      interior de la llanta
// #declare RBSA_DefaultTexturaMetalica                 = textura ...
//      Define la textura utilizada en el envarillado
// #declare RBSA_DefaultMaterialLuz                     = material ...
//      Define el material utilizado en la luz de seguridad
// #declare RBSA_LuzBicicleta                           = on
//      Si se declara off, no se dibuja la luz de seguridad
//
// Para colocarlo simplemente
// #include "RBSA.inc"
// object { RBSA_RuedaBicicletaPequena() }
//
// Otro ejemplo con modificador
// #include "RBSA.inc"
// #declare RBSA_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.2 RCPS_Rust                          ]
//     [ 0.8 RCPS_TexturaMetalica               ]
//   }
// }
// object       { RBSA_RuedaBicicletaPequena() }
//

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "RBSA.inc"

#local   FactorAcercamiento             = 2;

object          {      
  RBSA_RuedaBicicletaPequena()
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}




