// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 abril 2011
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// La macro RCPS_Capullo( Semilla, TotalHojas )
// genera un objeto con
// las siguientes caracteristicas
// Base de Capullo en origen
// orientado hacia y+
// Alto Capullo         : 70*L en y
// Radio Capullo        : 25*L aprox
// Largo Tallo          : 170*L aprox
// Radio Tallo          : 3.0*L
// Final Tallo          : Aleatorio en RCPS_FinalTallo
//              El vector 3D se genera automaticamente con la macro
// Los parametros serian
//      Semilla         : Numero seed para aleatoriedad
//                        misma Semilla implica misma flor
//      TotalHojas      : Numero de hojas en el tallito
//                        a partir de 0
//
// La macro RCPS_Rosa( Semilla, TotalHojas )
// genera un objeto con
// las siguientes caracteristicas
// Base de Capullo en origen
// orientado hacia y+
// Alto Rosa            : 37*L en y
// Radio Rosa           : 25*L aprox
// Largo Tallo          : 170*L aprox
// Radio Tallo          : 1.5*L
// Final Tallo          : Aleatorio en RCPS_FinalTallo
//              El vector 3D se genera automaticamente con la macro
// Los parametros serian
//      Semilla         : Numero seed para aleatoriedad
//                        misma Semilla implica misma flor
//      TotalHojas      : Numero de hojas en el tallito
//                        a partir de 0
//
// Los objetos tambien se pueden generar via una macro principal
// #macro   RCPS_FlorPlasticaColorVariado
//        ( Estilo, Semilla, TexturaPrincipal,
//              TexturaSecundaria, TexturaHoja, TexturaTallo, TotalHojas  )
//  Existen dos estilos predefinidos
//      Estilo                  : RCPS_EstiloCapullo y RCPS_EstiloRosa
//      Semilla                 : Numero seed para aleatoriedad
//      TexturaPrincipal        : Se aplica a los petalos
//      TexturaSecundaria       : Se aplica a los estambres
//      TexturaHojas            : Se aplica a las hojas
//      TexturaTallo            : Se aplica al tallito
//      TotalHojas              : A partir de 0, controla el total
//              de hojas en el tallito
//
// Las siguientes variables no deberian modificarse
// RCPS_TexturaPrincipalCapullo
//      Define la textura utilizada en los petalos del capullo
// RCPS_TexturaSecundariaCapullo
//      Define la textura utilizada en los estambres del capullo
// RCPS_TexturaHojaCapullo
//      Define la textura utilizada en las hojas del capullo
// RCPS_TexturaTalloCapullo
//      Define la textura utilizada en el tallo del capullo
// RCPS_TexturaPrincipalRosa
//      Define la textura utilizada en los petalos de la rosa
// RCPS_TexturaSecundariaRosa
//      Define la textura utilizada en los estambres de la rosa
// RCPS_TexturaHojaRosa
//      Define la textura utilizada en las hojas de la rosa
// RCPS_TexturaTalloRosa
//      Define la textura utilizada en el tallo de la rosa
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare RCPS_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare RCPS_TexturaPrincipalCapulloDefault         = texture ...
//      Define la textura utilizada en los petalos del capullo
// #declare RCPS_TexturaSecundariaCapulloDefault        = texture ...
//      Define la textura utilizada en los estambres del capullo
// #declare RCPS_TexturaHojaCapulloDefault              = texture ...
//      Define la textura utilizada en las hojas del capullo
// #declare RCPS_TexturaTalloCapulloDefault             = texture ...
//      Define la textura utilizada en el tallo del capullo
// #declare RCPS_TexturaPrincipalRosaDefault            = texture ...
//      Define la textura utilizada en los petalos de la rosa
// #declare RCPS_TexturaSecundariaRosaDefault           = texture ...
//      Define la textura utilizada en los estambres de la rosa
// #declare RCPS_TexturaHojaRosaDefault                 = texture ...
//      Define la textura utilizada en las hojas de la rosa
// #declare RCPS_TexturaTalloRosaDefault                = texture ...
//      Define la textura utilizada en el tallo de la rosa
//
// Para colocarlo simplemente
// #include "RCPS.inc"
// object { RCPS_Rosa( 1232, 4 ) }
//
// Otro ejemplo con modificador
// #include "RCPS.inc"
// #declare RCPS_TexturaPrincipalRosaDefault    = texture       {
//   average
//   texture_map        {
//     [ 0.5 RCPS_TexturaPrincipalRosa    ]
//     [ 0.5 RCPS_TexturaPrincipalCapullo ]
//   }
// }
// object       { RCPS_Rosa( 1232, 4 ) }
//


#include "colors.inc"

#local   EjeMejorado            = false;
#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "RCPS.pov"

object          {
  RCPS_Capullo( 100, 6.0 )
  rotate        -45*x
  translate     -0.05*x-2.40*z
}

object          {
  RCPS_Rosa( 100, 5.0 )
  rotate        -45*x
  translate     +0.05*x-2.40*z
}
