// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 febrero 2011
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Facil de usar, tan simple como
// #include "STMC.inc"
// object       { STMC_Silla() }
// #macro STMC_Silla()
//      Macro para SillaTerrazaMesaCircular, genera
//      una version default del objeto
// El objeto tambien puede generarse con la siguiente macro
// #macro STMC_MacroSilla ( GruesoVarilla, GruesoAsiento, 
//                        TexturaMetal, TexturaTela )
//      GruesoVarilla   : Grueso de las varillas, default es 8*L.
//      GruesoAsiento   : Grueso del asiento, default es 29*L.
//      TexturaMetal    : texture { ... }, a aplicar a las varillas.
//      TexturaTetal    : texture { ... }, a aplicar al asiento,
//                              respaldo y brazos de la silla.
// DiametroVarilla      = 8*L
// GruesoAsiento        = 29*L 
// Alto                 = 722*L 
// AltoAsiento          = 323*L
// RadioSillaPlano      = 143*L
// ProfundidadTrasera   = 185*L (a partir de centro de Silla )
// ProfundidadDelantera = 150*L (a partir de centro de Silla )
// ProfundidadRespaldo  = 147*L (a partir de centro de Silla )
// TamanoMaximoFrontal  = 560*L
// El circulo del asiento directamente sobre (y) del origen.
// Las patas reposan en el plano XZ.  Frente hacia z-. 
// Variables generadas con cada llamado de la macro:
// STMC_AlturaAsiento   : Da la altura del asiento
// STMC_RadioAsiento    : Da el radio plano del asiento  
//
// Se declaran las siguientes variables textura "default"
// que no deberian modificarse
// STMC_TexturaMetal
// STMC_TexturaTela
// El archivo posee los siguientes modificadores
// #declare STMC_POV3_1                 = off;
//      Para activar modo de compatibilidad con POVRay 3.1.
//      en algunas versiones se activa automaticamente.
//      Deberia activarse antes del include      
// #declare STMC_TexturaMetalDefault    = texture { STMC_TexturaMetal }
//      Para cambiar la textura default a aplicar en la STMC_Silla()
// #declare STMC_TexturaTelaDefault     = texture { STMC_TexturaTela  }
//      Para cambiar la textura defaule de tela en STMC_Silla()
// #include "STMC.inc"  
// #include "textures.inc"
// #declare STMC_TexturaMetalDefault = texture       {
//      average
//      texture_map     {
//              [ 0.5 STMC_TexturaMetal ]
//              [ 0.5 RustyIron         ]
//      }
// }
// object               {
//   STMC_Silla()
// }
// sphere               {
//   0, 0.05
//   translate  ( STMC_AlturaAsiento+0.05 )*y      
//   pigment            { Red }
// }
//
// Aclaracion:
// Las macros STMC_Reorient_Trans y STMC_Axis_Rotate_Trans
// se transcribe casi identica a la original
// en "transforms.inc" Reorient_Trans y Axis_Rotate_Trans
// se copia por compatibilidad con POVRay 3.1.
// La macro STMC_VPerp_To_Vector
// se tomo de "math.inc" VPerp_To_Vector
// por compatibilidad con POVRay 3.1.
//

#include "colors.inc"
#include "STMC.inc"    

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
object          {
  STMC_Silla()
  translate     -0.35*y-z
}


